;*************************************************************************
;**	Endpoints.asm, writen by Masyanya (ASDC) on 02.03.2007, main programmer of 
;** r.a.m. factory Co. design group.
;**	This file consists endpoints positions for USB interface
;** ver. 2.00 (evalution of version 1.03 from 07.03.2005) algorithms. 
;** ALL RIGHTS RESERVED for r.a.m. factory Co. Please remember this!!!!
;** Using frequency 15MHz :-)
;*************************************************************************
/*
!Please remember!
This file is INTELLECTUAL PROPERTY of r.a.m. factory Co.
*/

.cseg
.org 0x0c00
InEndpoints:
		rjmp InEndPoint0
		rjmp InEndPoint1
		rjmp InEndPoint2
		rjmp InEndPoint3
		rjmp InEndPoint4
		rjmp InEndPoint5
		rjmp InEndPoint6
		rjmp InEndPoint7
OutEndpoints:
		rjmp OutEndPoint0
		rjmp OutEndPoint1
		rjmp OutEndPoint2
		rjmp OutEndPoint3
		ret
		ret

;********************************************************
;** Setup PIPE = 0
;********************************************************
;** Out Setup Pipe = 0x00
OutEndPoint0:
		rcall	SendACK			;akceptovanie Setup Data paketu	;ENG;accept Setup Data packet
		ldi		ProcessingStatuses,DO_SETUP_DATA
		ret
;** In Setup Pipe = 0x80
InEndPoint0:
		cpi		ProcessingStatuses,DO_SETUP_ANSWER_PREPARED;Anser not ready
		brne	NoReadySend

		rcall	SendUSBAnswer	;Send prepared USB ansver to host

		cpi		EngineState,ADDRCH_STATE ;Is address change?
		breq	SetUSBAddress	;goto change address

		ldi		EngineState,IN_STATE
		ldi		ProcessingStatuses,DO_SETUP_BUFFER_SEPARATION
		ret
;********************************************************
SetUSBAddress:
		lds		DeviceAddress,DeviceAddressSRAM
		ret

NoReadySend:
		rcall	SendNAK		;Device not ready to answer!
		ret					;Return to interrupt handler

;********************************************************
;** In/Out PIPE = 2
;********************************************************
;** Out Pipe = 0x02
OutEndPoint2:
		cpi		ProcessingStatuses,DO_PS_DATA_CARD
		breq	DataMakerInProcess

		ldi		ProcessingStatuses,DO_PS_DATA_CARD
		rcall	SendACK			;Sending ACK then device is

		ret
DataMakerInProcess:
		rcall	SendNAK			;Sending NAK then last data is not writen
		ret
;** In Pipe = 0x82
InEndPoint2:
;If no data - send NAK Answer
		cpi		ProcessingStatuses,DO_ANSWER_PREPARED
		brne	WaitForBULKData

		;send our BULK data
		rcall	SendBULK_Data

;Test for last packet sign.
		mov		T01,PSDataSize
		inc		T01
		and		T01,T01
		brne	NoLastPacket
;We sended last packet, clear ALL.
		clr		PSDataSize

		ldi		YH,High(PSREADER_Buffer)
		ldi		YL,Low(PSREADER_Buffer)

		sts		PSDATAHI,YH
		sts		PSDATALO,YL

		clr		ProcessingStatuses
		ret
NoLastPacket:
		ldi		EngineState,IN_STATE
		ldi		ProcessingStatuses,DO_PS_DATA_SENDER
		ret
WaitForBULKData:
		rcall	SendNAK	;Sending NAK then last data is not writen
		ldi		ProcessingStatuses,DO_PS_DATA_SENDER
		ret


;********************************************************
;** In/Out PIPE = 1
;********************************************************
;** Out Pipe = 0x01
OutEndPoint1:
		;is our stop vibration
		lds		T01,USB_InPacket+1
		cpi		T01,INIT_VIBRATION
		breq	InitFF

		rcall	CopyFFData
		ldi		T01,1<<JOY1_FORCE
		or		MainSlotsFlags,T01
		rcall	SendACK			;accept Setup Data packet
		ret
InitFF:
		ldi		T01,~(1<<JOY1_FORCE)
		and		MainSlotsFlags,T01

		rcall	SendACK			;accept Setup Data packet
		ret
;** In Pipe = 0x81
InEndPoint1:
		sbrs	MainSlotsFlags,JOYA_NEEDSEND
		rjmp	NoDataChanged

		rcall	SendJoyAData

		rjmp	EndOfSend
NoDataChanged:	
		rcall	SendNAK
EndOfSend:
		ldi		T01,~(1<<JOYA_NEEDSEND)
		and		MainSlotsFlags,T01

		ldi		T01,1<<JOYA_NEEDREAD
		or		MainSlotsFlags,T01
		ret
;********************************************************
;** In/Out PIPE = 3
;********************************************************
;** Out Pipe = 0x03
OutEndPoint3:
		rcall	SendACK			;akceptovanie Setup Data paketu	;ENG;accept Setup Data packet
		ret
;** In Pipe = 0x83
InEndPoint3:
		sbrs	AnotherJoyFlags,JOYB_NEEDSEND
		rjmp	NoBDataChanged

		rcall	SendJoyBData

		rjmp	EndOfBSend
NoBDataChanged:	
		rcall	SendNAK
EndOfBSend:
		ldi		T01,~(1<<JOYB_NEEDSEND)
		and		AnotherJoyFlags,T01

		ldi		T01,1<<JOYB_NEEDREAD
		or		AnotherJoyFlags,T01
		ret
;NES joystick 1 pooling endpoint
InEndPoint4:
		sbrs	additional_flgs,NESJOY1_NEEDSEND
		rjmp	NoNJ1DataChanged

		rcall	SendNJoy1Data

		rjmp	EndOfNJ1Send
NoNJ1DataChanged:	
		rcall	SendNAK
EndOfNJ1Send:
		ldi		T01,~(1<<NESJOY1_NEEDSEND)
		and		additional_flgs,T01

		ldi		T01,1<<NESJOY1_NEEDREAD
		or		additional_flgs,T01
		ret
;NES joystick 2 pooling endpoint
InEndPoint5:
		sbrs	additional_flgs,NESJOY2_NEEDSEND
		rjmp	NoNJ2DataChanged

		rcall	SendNJoy2Data

		rjmp	EndOfNJ2Send
NoNJ2DataChanged:	
		rcall	SendNAK
EndOfNJ2Send:
		ldi		T01,~(1<<NESJOY2_NEEDSEND)
		and		additional_flgs,T01

		ldi		T01,1<<NESJOY2_NEEDREAD
		or		additional_flgs,T01
		ret

;SEGA joystick 1 pooling endpoint
InEndPoint6:
		sbrs	additional_flgs,SEGAJOY1_NEEDSEND
		rjmp	NoSJ1DataChanged

		rcall	SendSJoy1Data

		rjmp	EndOfSJ1Send
NoSJ1DataChanged:	
		rcall	SendNAK
EndOfSJ1Send:
		ldi		T01,~(1<<SEGAJOY1_NEEDSEND)
		and		additional_flgs,T01

		ldi		T01,1<<SEGAJOY1_NEEDREAD
		or		additional_flgs,T01
		ret
;SEGA joystick 2 pooling endpoint
InEndPoint7:
		sbrs	additional_flgs,SEGAJOY2_NEEDSEND
		rjmp	NoSJ2DataChanged

		rcall	SendSJoy2Data

		rjmp	EndOfSJ2Send
NoSJ2DataChanged:	
		rcall	SendNAK
EndOfSJ2Send:
		ldi		T01,~(1<<SEGAJOY2_NEEDSEND)
		and		additional_flgs,T01

		ldi		T01,1<<SEGAJOY2_NEEDREAD
		or		additional_flgs,T01
		ret
;.include "joy_pid.inc"
