.equ		N_CLK	= PA6
.equ		N_STB	= PE2
.equ		NDA0	= PA7
.equ		NDB0	= PD1

.equ		BUTTONB	= 1<<0x00
.equ		BUTTONA	= 1<<0x01
.equ		START	= 1<<0x02
.equ		SELECT	= 1<<0x03

read_nes:
	;clear prebuffer
	clr		T00
	clr		T01
	clr		T02
;Set ports directions
	;set as input
	cbi		DDRA,NDA0
	cbi		DDRD,NDB0
	;set as output
	sbi		DDRA,N_CLK
	sbi		DDRE,N_STB
	;set zeros into ports
	cbi		PORTE,N_STB
	cbi		PORTA,N_CLK
	nop
	nop
	nop
	sbi		PORTA,N_CLK
	;latch data
	nop
	nop
	nop
	sbi		PORTE,N_STB
	nop
	nop
	nop
	cbi		PORTE,N_STB
	nop
	nop
	nop
	cbi		PORTA,N_CLK
	nop
	nop
	;get "B" state
	sbis	PINA,NDA0
	ori		T00,BUTTONB

	sbis	PIND,NDB0
	ori		T01,BUTTONB

	rcall	nes_clk

	;get "A" state
	sbis	PINA,NDA0
	ori		T00,BUTTONA

	sbis	PIND,NDB0
	ori		T01,BUTTONA

	rcall	nes_clk

	;get "select" state
	sbis	PINA,NDA0
	ori		T00,SELECT

	sbis	PIND,NDB0
	ori		T01,SELECT

	rcall	nes_clk

	;get "start" state
	sbis	PINA,NDA0
	ori		T00,START

	sbis	PIND,NDB0
	ori		T01,START

	;compare data
	lds		T03,NES1DATA+4
	cpse	T03,T00
	ori		T02,1<<NESJOY1_NEEDSEND

	lds		T03,NES2DATA+4
	cpse	T03,T01
	ori		T02,1<<NESJOY2_NEEDSEND

	;Store received data
	sts		NESJOY1D+2,T00
	sts		NESJOY2D+2,T01
	;clear prebuffer
	clr		T00
	clr		T01

	rcall	nes_clk

	;get "UP" state
	sbis	PINA,NDA0
	ldi		T00,0x81

	sbis	PIND,NDB0
	ldi		T01,0x81

	rcall	nes_clk

	;get "DOWN" state
	sbis	PINA,NDA0
	ldi		T00,0x7f

	sbis	PIND,NDB0
	ldi		T01,0x7f

	;compare data
	lds		T03,NES1DATA+3
	cpse	T03,T00
	ori		T02,1<<NESJOY1_NEEDSEND

	lds		T03,NES2DATA+3
	cpse	T03,T01
	ori		T02,1<<NESJOY2_NEEDSEND

	;Store received data
	sts		NESJOY1D+1,T00
	sts		NESJOY2D+1,T01
;y
	;clear prebuffer
	clr		T00
	clr		T01

	rcall	nes_clk

	;get "LEFT" state
	sbis	PINA,NDA0
	ldi		T00,0x81

	sbis	PIND,NDB0
	ldi		T01,0x81

	rcall	nes_clk

	;get "RIGHT" state
	sbis	PINA,NDA0
	ldi		T00,0x7f

	sbis	PIND,NDB0
	ldi		T01,0x7f

	;compare data
	lds		T03,NES1DATA+2
	cpse	T03,T00
	ori		T02,1<<NESJOY1_NEEDSEND

	lds		T03,NES2DATA+2
	cpse	T03,T01
	ori		T02,1<<NESJOY2_NEEDSEND

	;Store received data
	sts		NESJOY1D+0,T00
	sts		NESJOY2D+0,T01

	push	ByteCount
	push	YH
	push	YL
	push	T02
	sbrc	T02,NESJOY1_NEEDSEND
	rcall	UpdateNESJoy1
	sbrc	T02,NESJOY2_NEEDSEND
	rcall	UpdateNESJoy2

	pop		T02
	pop		YL
	pop		YH
	pop		ByteCount
	
	andi	additional_flgs,~((1<<NESJOY1_NEEDREAD)|(1<<NESJOY2_NEEDREAD))

;	ori		additional_flgs,1<<NESJOY1_NEEDSEND
;	ori		additional_flgs,1<<NESJOY2_NEEDSEND

	ret

UpdateNESJoy1:
	ldi		T00,0x01;store report ID
	sts		NES1DATA+1,T00

	lds		T00,NESJOY1D
	sts		NES1DATA+2,T00

	lds		T00,NESJOY1D+1
	sts		NES1DATA+3,T00

	lds		T00,NESJOY1D+2
	sts		NES1DATA+4,T00

	ldi	ByteCount,4+2
	ldi	YL,Low(NES1DATA)
	ldi	YH,High(NES1DATA)
	
	rcall CalcCRC16

	;set send flag
	ori	additional_flgs,(1<<NESJOY1_NEEDSEND)

	ret
UpdateNESJoy2:
	ldi		T00,0x01;store report ID
	sts		NES2DATA+1,T00

	lds		T00,NESJOY2D
	sts		NES2DATA+2,T00

	lds		T00,NESJOY2D+1
	sts		NES2DATA+3,T00

	lds		T00,NESJOY2D+2
	sts		NES2DATA+4,T00

	ldi	ByteCount,4+2
	ldi	YL,Low(NES2DATA)
	ldi	YH,High(NES2DATA)
	
	rcall CalcCRC16

	;set send flag
	ori	additional_flgs,(1<<NESJOY2_NEEDSEND)

	ret

nes_clk:
	cbi		PORTA,N_CLK
	rcall	psx_delay
	sbi		PORTA,N_CLK
	rcall	psx_delay
	cbi		PORTA,N_CLK
	ret
