
.cseg
PrepareContinuousBuffer:
/*		mov	T00,TransmitPart
		cpi	T00,1
		brne	NextAnswerInBuffer	;If buffer empty
		rcall	MakeEmptyBuffer		;Prepare zero answer
		ret
NextAnswerInBuffer:
		dec	TransmitPart			;Decrement general length of answer
ComposeNextAnswerPart:
		mov	T01,TotalBytesToSend	;Decrement number of bytes to transmit
		subi	T01,8				;Is is necessary to send more as 8 byte
		ldi	T03,8					;If yes - send only 8 byte
		brcc	Nad8Bytov
		mov	T03,TotalBytesToSend	;Otherwise send only given number of bytes
		clr	TransmitPart
		inc	TransmitPart			;And this will be last answer
Nad8Bytov:
		mov	TotalBytesToSend,T01	;Decremented number of bytes to TotalBytesToSend
PrepareShortBuffer:
		rcall	LoadXXXDescriptor
PrepareNormalBuffer:
		rcall	ToggleDATAPID		;Change DATAPID
		ldi	ByteCount,0x02			;Length of output buffer (only SOP and PID)
		add	ByteCount,T03			;+ number of bytes
		rcall	CalcCRC16			;Addition of CRC to buffer
		inc	ByteCount				;Length of output buffer + CRC16
		inc	ByteCount
		ret							;finish
*/

		mov	T00,TransmitPart
		and TransmitPart,TransmitPart
		breq MakeEmptyBuffer
		dec	T00
		breq	PrepareLastPacket	;If buffer empty
;NextAnswerInBuffer:
		dec	TransmitPart			;Decrement general length of answer
		ldi	T03,8
PrepareShortBuffer:
		mov		ByteCount,T03		;If yes - send only 8 byte
		rcall	LoadMyPacketData
PrepareNormalBuffer:
		rcall	ToggleDATAPID		;Change DATAPID
		ldi	ByteCount,0x02			;Length of output buffer (only SOP and PID)
		add	ByteCount,T03			;+ number of bytes
		rcall	CalcCRC16			;Addition of CRC to buffer
		inc	ByteCount				;Length of output buffer + CRC16
		inc	ByteCount
		ret							;finish
PrepareLastPacket:
;		mov	TransmitPart,T00

		and TotalBytesToSend,TotalBytesToSend
		breq MakeEmptyBuffer

		mov T03,TotalBytesToSend
		clr	TotalBytesToSend
		rjmp PrepareShortBuffer

LoadDescriptorFromROM:
		lpm							;Load from ROM position pointer to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer
		adiw	ZH:ZL,1				;Increment index to ROM
		dec	ByteCount				;Till are not all bytes
		brne	LoadDescriptorFromROM	;Then load next
		rjmp	EndFromRAMROM		;Otherwise finish
;------------------------------------------------------------------------------------------
LoadDescriptorFromROMZeroInsert:
		lpm							;Load from ROM position pointer to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer

		bst	CurrentDataPosition,3	;If bit 3 is one - don't insert zero
		brtc	InsertingZero		;Otherwise zero will be inserted
		adiw	ZH:ZL,1				;Increment index to ROM
		lpm							;Load from ROM position pointer to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer
		clt							;and clear
		bld	CurrentDataPosition,3	;The third bit in CurrentDataPosition - for to the next zero insertion will be made
		rjmp	InsertingZeroEnd	;And continue
InsertingZero:
		clr	PRGMP					;For insertion of zero
		st	Y+,PRGMP				;Zero save to buffer and increment buffer
InsertingZeroEnd:
		adiw	ZH:ZL,1				;Increment index to ROM
		subi	ByteCount,2			;Till are not all bytes
		brne	LoadDescriptorFromROMZeroInsert	;Then load next
		rjmp	EndFromRAMROM		;Otherwise finish
;------------------------------------------------------------------------------------------
LoadDescriptorFromSRAM:
		ld	PRGMP,Z					;Load from position RAM pointer to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer
		adiw	ZH:ZL,1				;Increment index to RAM
		dec	ByteCount				;Till are not all bytes
		brne	LoadDescriptorFromSRAM	;Then load next
		rjmp	EndFromRAMROM		;Otherwise finish
;------------------------------------------------------------------------------------------
LoadDescriptorFromEEPROM:
		out	EEARL,ZL				;Set the address EEPROM Lo
		out	EEARH,ZH				;Set the address EEPROM Hi
		sbi	EECR,EERE				;Read EEPROM to register EEDR
		in	PRGMP,EEDR				;Load from EEDR to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer
		adiw	ZH:ZL,1				;Increment index to EEPROM
		dec	ByteCount				;Till are not all bytes
		brne	LoadDescriptorFromEEPROM;Then load next
		rjmp	EndFromRAMROM		;inak skonci	;ENG;otherwise finish
;------------------------------------------------------------------------------------------
LoadDescriptorFromEEPROMZeroInsert:
LoadDescriptorFromEEPROMZeroPut:
		out	EEARL,ZL				;Set the address EEPROM Lo
		out	EEARH,ZH				;Set the address EEPROM Hi
		sbi	EECR,EERE				;vycitaj EEPROM do registra EEDR	;ENG;read EEPROM to register EEDR
		in	PRGMP,EEDR				;Load from EEDR to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer

		bst	CurrentDataPosition,3	;If bit 3 is one - don't insert zero
		brtc	PutZero				;Otherwise zero will be inserted
		adiw	ZH:ZL,1				;Increment index to ROM
		out	EEARL,ZL				;Set the address EEPROM Lo
		out	EEARH,ZH				;Set the address EEPROM Hi
		sbi	EECR,EERE				;Read EEPROM to register EEDR
		in	PRGMP,EEDR				;Load from EEDR to PRGMP
		st	Y+,PRGMP				;PRGMP save to buffer and increment buffer
		clt							;And clear
		bld	CurrentDataPosition,3	;The third bit in CurrentDataPosition - 
									;	for to the next zero insertion will be made
		rjmp	PutZeroEnd			;And continue
PutZero:
		clr	PRGMP			;For insertion of zero
		st	Y+,PRGMP		;Zero save to buffer and increment buffer
PutZeroEnd:
		adiw	ZH:ZL,1							;Increment index to ROM
		subi	ByteCount,2						;Till are not all bytes
		brne	LoadDescriptorFromEEPROMZeroPut	;Then load next
		rjmp	EndFromRAMROM					;Otherwise finish
;------------------------------------------------------------------------------------------
LoadXXXDescriptor:
		ldi	ByteCount,8				;How many bytes to store
LoadMyPacketData:
		ldi	YL,low(USB_OutPacket)+1	;From start from our buffer, scip PID byte
		ldi	YH,high(USB_OutPacket)

LoadPacketData:
;************0=ROM,1=RAM,2=EEPROM,4=ROM UNI,0x80=EEPROM UNI***********
		and	CurrentDataPosition,CurrentDataPosition
		brne	FromRAMorEEPROM
FromROM:
;******************Read from ROM*********************
		rjmp	LoadDescriptorFromROM
FromRAMorEEPROM:
;**************read from ROM, convert to UNICODE English**************
		sbrc	CurrentDataPosition,2			
		rjmp	LoadDescriptorFromROMZeroInsert	
;**************read from EEPROM, convert to UNICODE English**************
		sbrc	CurrentDataPosition,7
		rjmp	LoadDescriptorFromEEPROMZeroInsert
;******************read from SRAM********************
		sbrc	CurrentDataPosition,0			
		rjmp	LoadDescriptorFromSRAM		
;******************And read from EEPROM**************
		rjmp	LoadDescriptorFromEEPROM

EndFromRAMROM:
		ldi	YL,low(USB_OutPacket)	;Restore transmitting buffer pointer
		ldi	YH,high(USB_OutPacket)
		ret
;------------------------------------------------------------------------------------------
ToggleDATAPID:
		lds	T00,USB_OutPacket	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	SendData0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
SendData0PID:
		sts	USB_OutPacket,T00	;DATA0PID byte
		ret

