;********************************************************************************
;**	data.inc, writen by Masyanya (ASDC), r.a.m. factory 02.03.2007
;**	This file consists device descriptor and ets... EEPROM data, - Device Name,
;**		ALL RIGHTS RESERVED
;********************************************************************************
/*
!Please remember!
This file is INTELLECTUAL PROPERTY of r.a.m. factory Co.
*/

.cseg

TglSJoy2DATAPID:
		lds	T00,SEGA2BULK	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	BulkSJ2DATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
BulkSJ2DATA0PID:
		sts	SEGA2BULK,T00	;DATA0PID byte
		ret
SendSJoy2Data:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglSJoy2DATAPID;Togle data PID

		ldi		ByteCount,4+2+2

		ldi	YL,low(SEGA2BULK)
		ldi	YH,high(SEGA2BULK)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

TglSJoy1DATAPID:
		lds	T00,SEGA1BULK	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	BulkSJ1DATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
BulkSJ1DATA0PID:
		sts	SEGA1BULK,T00	;DATA0PID byte
		ret
SendSJoy1Data:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglSJoy1DATAPID;Togle data PID

		ldi		ByteCount,4+2+2

		ldi	YL,low(SEGA1BULK)
		ldi	YH,high(SEGA1BULK)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

TglNJoy2DATAPID:
		lds	T00,NES2DATA	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	BulkNJ2DATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
BulkNJ2DATA0PID:
		sts	NES2DATA,T00	;DATA0PID byte
		ret
SendNJoy2Data:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglNJoy2DATAPID;Togle data PID

		ldi		ByteCount,4+2+2

		ldi	YL,low(NES2DATA)
		ldi	YH,high(NES2DATA)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

TglNJoy1DATAPID:
		lds	T00,NES1DATA	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	BulkNJ1DATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
BulkNJ1DATA0PID:
		sts	NES1DATA,T00	;DATA0PID byte
		ret
SendNJoy1Data:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglNJoy1DATAPID;Togle data PID

		ldi		ByteCount,4+2+2

		ldi	YL,low(NES1DATA)
		ldi	YH,high(NES1DATA)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

SendBULK_Data:
		push	YL
		push	YH
		push	ByteCount

		mov		ByteCount,BulkByteCount
		rcall	TglBulkDATAPID;Togle data PID
		ldi	YL,low(USB_BulkBuffer)
		ldi	YH,high(USB_BulkBuffer)
		rcall	SendUSBBuffer

		clr		BulkByteCount
		pop		ByteCount
		pop		YH
		pop		YL
		ret

TglBulkDATAPID:
		lds	T00,USB_BulkBuffer	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	BulkDATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
BulkDATA0PID:
		sts	USB_BulkBuffer,T00	;DATA0PID byte
		ret

TglJoyADATAPID:
		lds	T00,USB_JoyABulkBuffer	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	JoyADATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
JoyADATA0PID:
		sts	USB_JoyABulkBuffer,T00	;DATA0PID byte
		ret

TglJoyBDATAPID:
		lds	T00,USB_JoyBBulkBuffer	;Load last PID
		cpi	T00,DATA1PID		;If last was DATA1PID byte
		ldi	T00,DATA0PID
		breq	JoyBDATA0PID	;Then send zero answer with DATA0PID
		ldi	T00,DATA1PID		;Otherwise send zero answer with DATA1PID
JoyBDATA0PID:
		sts	USB_JoyBBulkBuffer,T00	;DATA0PID byte
		ret

SendEmptyBulkBuffer:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglBulkDATAPID;Togle data PID

		clr		YL
		sts		USB_BulkBuffer+1,YL
		sts		USB_BulkBuffer+2,YL
		
		ldi		ByteCount,0x04

		ldi	YL,low(USB_BulkBuffer)
		ldi	YH,high(USB_BulkBuffer)
		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

SendJoyAData:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglJoyADATAPID;Togle data PID

		ldi		ByteCount,7+2+2

		ldi	YL,low(USB_JoyABulkBuffer)
		ldi	YH,high(USB_JoyABulkBuffer)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

SendJoyBData:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglJoyBDATAPID;Togle data PID

		ldi		ByteCount,7+2+2

		ldi	YL,low(USB_JoyBBulkBuffer)
		ldi	YH,high(USB_JoyBBulkBuffer)

		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

;SendEmptyJoyBuffer:
;		push	YL
;		push	YH
;		push	ByteCount

;		rcall	TglJoyDATAPID;Togle data PID

;		lds		YL,USB_JoyABuffer
;		sts		TMPBUFFER,YL

;		clr		YL
;		sts		TMPBUFFER+1,YL
;		sts		TMPBUFFER+2,YL
		
;		ldi		ByteCount,0x04

;		ldi	YL,low(TMPBUFFER)
;		ldi	YH,high(TMPBUFFER)
;		rcall	SendUSBBuffer

;		pop		ByteCount
;		pop		YH
;		pop		YL
;		ret

;** In params
;** T03 - Number Of bytes to transmit
;** T00 - Number of bytes in packet sign (0 = 8 Bytes,1= 16 Bytes,2 - 32 Bytes)
;** ByteCount = SizeOfBulkPacket
;** Out params
;** AmountBulkPacks - Number Of packets
;** LastPacketSize - Size of last packet
SetLastPacketSign:
	clr		PSDataSize ;set last packet sign
	dec		PSDataSize ;last packet sign is -1 (BYTE)=>max packet size 254
	ret
CompareLongBULKPacket:
	and		PSDataSize,PSDataSize
	breq	NoPSCARDData

	push	ByteCount

	mov		T00,PSDataSize 
	SBCI	T00,BULK_OUTPACKET_SIZE
;	tst		T00
;	breq	PRECLR;is last BULK packet?
	brcc	NoCLR;is last BULK packet?

	mov		ByteCount,PSDataSize;set BULK packet size
	rcall	SetLastPacketSign;set last packet sign
	rjmp	YesCLR
;PRECLR:
;	rcall	SetLastPacketSign;set last packet sign
;	rjmp	PostCLR;Detect sending full bulk buffer
NoCLR:
	cpi		T00,0x00
	brne	NoZero
	dec		T00
NoZero:
	mov		PSDataSize,T00;store new not sended data size

;PostCLR:
	ldi		ByteCount,BULK_OUTPACKET_SIZE;set BULK packet size
	
YesCLR:
	push	ZH
	push	ZL
	push	YH
	push	YL
	lds		ZH,PSDATAHI
	lds		ZL,PSDATALO

	ldi		YL,Low(USB_BulkBuffer+1)
	ldi		YH,High(USB_BulkBuffer+1)
	rcall	CalcCRC16AndCopy;add CRC16 to BULK buffer
	mov		BulkByteCount,ByteCount
	sts		PSDATAHI,ZH
	sts		PSDATALO,ZL
	pop		YL
	pop		YH
	pop		ZL
	pop		ZH
	pop		ByteCount
	ret
NoPSCARDData:
	push	T00
	ldi		T00,0x00
	sts		USB_BulkBuffer+1,T00
	sts		USB_BulkBuffer+2,T00

	ldi		T00,0x04;empty packet size
	mov		BulkByteCount,T00
	pop		T00
	rjmp	SetLastPacketSign
