;*************************************************************************
;**	crc.asm, writen by Masyanya (ASDC), r.a.m. factory 02.03.2007
;**	This file consists CRC 5, CRC 16 Calulate algorithms
;**		ALL RIGHTS RESERVED
;** Using frequency 15MHz :-)
;*************************************************************************

 .include "other.inc"
 .include "USB.inc"


.cseg
.equ CRC5Polynome = 0b10100000
.equ CRC16Polynome = 0b1010000000000001
 .include "USB.inc"

;calc CYCLIC REDUNDANCY CHECK, calculating CRC16 and CRC5, but CRC5 not used

CalcCRC16AndCopy:
	PUSH	ByteCount
;	subi	ByteCount,0x02
	push	XH
	push	YH
	push	YL
;	ADIW	YH:YL,1
	clr		T03

	ser		T00;LOBYTE
	ser		T01;HIBYTE
_CRCCalculatingLoop16:
		LD		T02,Z+
		ST		Y+,T02
_NextDataBit16:
		lsr	T01
		ror	T00
		brcs _CurrentMSBBitONE16
		brcc _CurrentMSBBitZERO16
_CurrentMSBBitONE16:
		lsr T02		
		brcs _NoXOR16
		rjmp _XOR16
_CurrentMSBBitZERO16:
		lsr T02		
		brcc _NoXOR16
_XOR16:
		ldi	XH,low(CRC16Polynome)
		eor T00,XH
		ldi	XH,high(CRC16Polynome)
		eor T01,XH
_NoXOR16:
		subi T03,0x20
		brne _NextDataBit16	
_NextDataByte16:
		dec ByteCount
		brne _CRCCalculatingLoop16

_EndCRCCalculating16:
	com T00
	com T01
	st	Y+,T00
	st	Y,T01
	pop	YL
	pop	YH
	pop	XH
	pop ByteCount
	ldi T00,0x04
	add ByteCount,T00
	ret

CalcCRC16:
	PUSH	ByteCount
	subi	ByteCount,0x02
	push	XH
	push	YH
	push	YL
	ADIW	YH:YL,1
	clr		T03

	ser		T00;LOBYTE
	ser		T01;HIBYTE
CRCCalculatingLoop16:	
		LD		T02,Y+
NextDataBit16:
		lsr	T01
		ror	T00
		brcs CurrentMSBBitONE16
		brcc CurrentMSBBitZERO16
CurrentMSBBitONE16:
		lsr T02		
		brcs NoXOR16
		rjmp XOR16
CurrentMSBBitZERO16:
		lsr T02		
		brcc NoXOR16
XOR16:
		ldi	XH,low(CRC16Polynome)
		eor T00,XH
		ldi	XH,high(CRC16Polynome)
		eor T01,XH
NoXOR16:
		subi T03,0x20
		brne NextDataBit16	
NextDataByte16:
		dec ByteCount
		brne CRCCalculatingLoop16

EndCRCCalculating16:
	com T00
	com T01
	st	Y+,T00
	st	Y,T01
	pop	YL
	pop	YH
	pop	XH
	pop ByteCount
	ret

;
;CalcCRC5:
;	push	BitInReg
;	push	BitStuff
;	push	YH
;	push	YL
;	ADIW	YH:YL,1
;T03 = last bits (T00*8+T01/0x20 = number of bits for CRC)
;	ldi		T03,0x60
;	mov		BitStuff,T03

;	ldi		T00,0b11111000;LOBYTE
;CRCCalculatingLoop:	
;		LD		T02,Y+
;NextDataBit:
;		lsr	T00
;		sbrc T00,0x02
;		rjmp CurrentMSBBitONE
;		rjmp CurrentMSBBitZERO
;CurrentMSBBitONE:
;		lsr T02		
;		brcs NoXOR8
;		rjmp XOR8
;CurrentMSBBitZERO:
;		lsr T02		
;		brcc NoXOR8
;XOR8:
;		ldi	BitInReg,CRC5Polynome
;		eor T00,BitInReg
;NoXOR8:
;		subi T03,0x20
;		cpse T03,BitStuff
;		rjmp NextDataBit	
;NextDataByte:
;		dec T04
;		cpi	T04,0x00
;		brne CRCCalculatingLoop
;		inc	T04
;		tst  BitStuff
;		breq EndCRCCalculating 
;		ld	T02,Y
;		clr BitStuff
;		rjmp NextDataBit

;EndCRCCalculating:
;	com T00
;	andi T00,0b11111000
;	ld	T02,Y
;	andi T02,0b00000111
;	or	T02,T00
;	st	X,T02

;	pop	YL
;	pop	YH
;	pop	BitStuff
;	pop	BitInReg
;	ret
 
