;********************************************************************************
;**	data.inc, writen by Masyanya (ASDC), r.a.m. factory 02.03.2007
;**	This file consists device descriptor and ets... EEPROM data, - Device Name,
;**		ALL RIGHTS RESERVED
;********************************************************************************
/*
!Please remember!
This file is INTELLECTUAL PROPERTY of r.a.m. factory Co.
*/
.equ	PSX_J1	=0x00
.equ	PSX_J2	=0x01
.equ	NES_J1	=0x02
.equ	NES_J2	=0x03
.equ	SEGA_J1	=0x04
.equ	SEGA_J1	=0x05

.eseg

;********************************Definitions*************************************
.equ	USBversion		=0x0110		;USB version = 1.10
.equ	VendorUSBID		=0x0000		;Vendor identifier for Atmel devices  =0x03EB
.equ	DeviceUSBID		=0x4344		;Product identifier ATmega8515 Test Device 
									;	on 15MHz = 0x51ee
.equ	DeviceVersion	=0x0073		;Product version number = 1.21
.equ	MaxUSBCurrent	=500		;Current consumption from USB = 500mA, 
									;	for 7.5v voltage generator
;********************************************************************************
DeviceDescriptor:
		.db	EndOfDeviceDescriptor-DeviceDescriptor,0x01
							;Descriptor size in bytes
							;Descriptor type: Device descriptor
		.dw	USBversion		;See "Definitions"
		.db	0x00,0x00		;Device class
							;Device subclass
		.db	0x00,0x08		;Protocol code
							;FI/FO size in bytes
		.dw	VendorUSBID		;See "Definitions"
		.dw	DeviceUSBID		;See "Definitions"
		.dw	DeviceVersion	;See "Definitions"
		.db	MANUFACTURER	;Index of String descriptor describing 
								;manufacturer
		.db	PRODUCT			;Index of string descriptor describing 
								;product
		.db	SERIAL			;Index of String descriptor describing 
								;the devices serial number. 
		.db	0x01			;Nuber of possible configurations
EndOfDeviceDescriptor:
;********************************************************************************
ConfigDescriptor:
		.db	0x9,0x02		;length, descriptor type
entireLengthDescriptors:
		.dw	ConfigDescriptorEnd - ConfigDescriptor			;entire length of all descriptors + HID 
numInterfaces:
		.db	7/*2*/,1			;numInterfaces, congiguration number
		.db	0,0x80			;string index (0=none), attributes; bus powered
		.db	MaxUSBCurrent/2 ;current consumption
;Card reader interface
CRInterfaceDescriptor:
		.db	EndOfCRInterfaceDescriptor-CRInterfaceDescriptor  ;    interface descriptor length
		.db	0x04,0			;interface descriptor; number of interface
		.db	0,2;3			;alternatively interface; number of endpoints except EP0
		.db	0x08,0			;interface class - HID; interface subclass
		.db	0,CRSERIAL		;protocol code; string index - Device name
EndOfCRInterfaceDescriptor:
		;Out endpoint Card Reader
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x82,0b00000010			;Endpoint address; transfer type - bulk
		.dw	BULK_OUTPACKET_SIZE		;Max packet sizet
		.db	0x19					;polling interval 5 ms
		;In endpoint Card Reader
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x02,0b00000010			;Endpoint address; transfer type - bulk
		.dw	BULK_INPACKET_SIZE		;Max packet size
		.db	0x19					;polling interval 5 ms
;PSX joy 1 int descriptor
Joy1InterfaceDescriptor:
		.db	EndOfJoy1InterfaceDescriptor-Joy1InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,1			;interface descriptor; number of interface
		.db	0,2;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,JOY1NAME		;protocol code; string index - Device name
EndOfJoy1InterfaceDescriptor:
HIDJ1Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw /*862;*/EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDJ1Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x81,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
		;Out Force Feedback
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x01,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet sizet
		.db	0x0a					;polling interval 10 ms
;Joy 2 interface
Joy2InterfaceDescriptor:
		.db	EndOfJoy2InterfaceDescriptor-Joy2InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,2			;interface descriptor; number of interface
		.db	0,2;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,JOY2NAME		;protocol code; string index - Device name
EndOfJoy2InterfaceDescriptor:
HIDJ2Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw EndOfReportDescriptor-ReportDescriptor;EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDJ2Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x83,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
		;Out Force Feedback
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x03,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet sizet
		.db	0x0a					;polling interval 10 ms
;Nes Joy 1 interface
NES1InterfaceDescriptor:
		.db	EndOfNES1InterfaceDescriptor-NES1InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,3			;interface descriptor; number of interface
		.db	0,1;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,NESNAME		;protocol code; string index - Device name
EndOfNES1InterfaceDescriptor:
HIDNES1Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw EndOfNESReportDescriptor-NESReportDescriptor;EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDNES1Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x84,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
;Nes Joy 1 interface
NES2InterfaceDescriptor:
		.db	EndOfNES2InterfaceDescriptor-NES2InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,4			;interface descriptor; number of interface
		.db	0,1;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,NESNAME		;protocol code; string index - Device name
EndOfNES2InterfaceDescriptor:
HIDNES2Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw EndOfNESReportDescriptor-NESReportDescriptor;EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDNES2Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x85,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
;SEGA Joy 1 interface
SEGA1InterfaceDescriptor:
		.db	EndOfSEGA1InterfaceDescriptor-SEGA1InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,5			;interface descriptor; number of interface
		.db	0,1;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,SEGANAME		;protocol code; string index - Device name
EndOfSEGA1InterfaceDescriptor:
HIDSEGA1Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw EndOfSEGAReportDescriptor-SEGAReportDescriptor;EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDSEGA1Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x86,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
;SEGA Joy 1 interface
SEGA2InterfaceDescriptor:
		.db	EndOfSEGA2InterfaceDescriptor-SEGA2InterfaceDescriptor  ;    interface descriptor length
		.db	0x04,6			;interface descriptor; number of interface
		.db	0,2;3			;alternatively interface; number of endpoints except EP0
		.db	0x03,0			;interface class - HID; interface subclass
		.db	0,SEGANAME		;protocol code; string index - Device name
EndOfSEGA2InterfaceDescriptor:
HIDSEGA2Descriptor:
		.db 0x09,0x21	; HID descriptor length , HID descriptor type (defined by USB)
		.dw 0x0110		; HID Class Specification release number
		.db	0x21,0x01			;Hardware target country.;	;Number of HID class descriptors to follow.
		.db	0x22
		.dw EndOfSEGAReportDescriptor-SEGAReportDescriptor;EndOfReportDescriptor-ReportDescriptor	;Report descriptor type.
EndOfHIDSEGA2Descriptor:
		;In endpoint Joy pooller
		.db 0x07,0x05				;Length, descriptor type - endpoint
		.db	0x87,0b00000011			;Endpoint address; transfer type - interrupt
		.dw	BULK_PACKET_SIZE		;Max packet size
		.db	0x08					;polling interval 8 ms
ConfigDescriptorEnd:
PresentedDevices:
		.db	(1<<PSX_J1)|(1<<PSX_J2)|(1<<NES_J1)|(1<<NES_J2)|(1<<SEGA_J1)|(1<<SEGA_J2)
;********************************************************************************
.equ	LANGID	= 0

LangIDStringDescriptor:
		.db	(LangIDStringDescriptorEnd-LangIDStringDescriptor),3	;Length, type 3 = string descriptor
		.dw	0x0409			;English = 0x0409, Russian = 0x0419
LangIDStringDescriptorEnd:
;********************************************************************************
.equ	MANUFACTURER	= 1

ManufacturerDescriptor:
	.db	(CopyRightEnd-CopyRight)*2+2,3;Length, type is string 
CopyRight:
		.db	"MASYANYA"
CopyRightEnd:
ManufacturerDescriptorEnd:
;***Hire device name*************************************************************
.equ	PRODUCT	= 2
ProductDescriptor:
	.db	(ProductDescriptorEnd-ProductString)*2+2,3;Length, type is 
														;string descriptor -3
ProductString:
	.db	"USB Play Station Interface Device"
ProductDescriptorEnd:
;********************************************************************************
.equ	JOY1NAME	= 3
Joy1NameDescriptor:
	.db	(Joy1NameDescriptorEnd-Joy1NameString)*2+2,3;Length, type is 
														;string descriptor -3
Joy1NameString:
	.db	"PSX JoyStick #1"
Joy1NameDescriptorEnd:
;********************************************************************************
;********************************************************************************
.equ	JOY2NAME	= 4
Joy2NameDescriptor:
	.db	(Joy2NameDescriptorEnd-Joy2NameString)*2+2,3;Length, type is 
														;string descriptor -3
Joy2NameString:
	.db	"PSX JoyStick #2"
Joy2NameDescriptorEnd:
;********************************************************************************
;********************************************************************************
.equ	NESNAME	= 5
NESNameDescriptor:
	.db	(NESNameDescriptorEnd-NESNameString)*2+2,3;Length, type is 
														;string descriptor -3
NESNameString:
	.db	"NES"
NESNameDescriptorEnd:
;********************************************************************************
.equ	SEGANAME	= 6
SEGANameDescriptor:
	.db	(SEGANameDescriptorEnd-SEGANameString)*2+2,3;Length, type is 
														;string descriptor -3
SEGANameString:
	.db	"SEGA"
SEGANameDescriptorEnd:
;********************************************************************************
.equ	CRSERIAL	= 7
CRDescriptor:
	.db	(CRDescriptorEnd-CRString)*2+2,3;Length, type is 
														;string descriptor -3
CRString:
	.db	"CARD READER"
CRDescriptorEnd:
;********************************************************************************
;********************************************************************************
.equ	SERIAL	= 8
SerialDescriptor:
	.db	(SerialDescriptorEnd-SerialString)*2+2,3;Length, type is 
														;string descriptor -3
SerialString:
	.db	"3.73.101"
SerialDescriptorEnd:
;********************************************************************************
EndDeviceInfo:
;.include "PhysDesc.inc"
