;*************************************************************************
;**	main.asm, writen by Masyanya (ASDC), r.a.m. factory 02.03.2007
;**	This file consists main programm loop
;**		ALL RIGHTS RESERVED
;** Using frequency 15MHz :-)
;*************************************************************************
.include "mem.inc"
.include "USB.inc"

.cseg
.org 3;INT_VECTORS_SIZE ; Start programm position
.include "bulk.asm"
.include "psx_joy.asm"
.include "psx_rc.asm"
.include "NES.asm"
.include "sega.asm"

Reset:
		ldi	T00,Low(StackBegin)	;INIT Stack LoByte
		out	SPL,T00
		ldi	T00,High(StackBegin);INIT Stack HiByte
		out	SPH,T00

		ldi	T00,0x80;Disable ACR
		out	ACSR,T00;

		rcall	PSX_Init_Ports	;Init PSX Card/Joy Ports
		rcall	psx_sendclose

		rcall	USBReset		;Throw device status to NULL
;MoveUP:
		clr		T00
		sts		ID1_IDLE,T00; init IDLE Byte.

		ldi	T00,0x03<<2		;INT0 on leading edge
		out	MCUCR,T00
		ldi	T00,1<<INT1		;enable external interrupt INT0
		out	GICR,T00

		sei			;enable external interrupt INT0

;		lds		T00,PSWRITER_Buffer+0x80
;		inc		T00
;		sts		PSWRITER_Buffer+0x80,T00
;		rcall	ReadJoySticks
;		rcall read_sega_2
;------------------------------------------------------------------------------------------
;**************Main program loop**************
Main:
;		rcall InEndPoint1
;		rcall InEndPoint3
	
		sbis	inputport,DMinusChannel	;Detect - Host Resetting USB lines to begin enumeration
		rjmp	CheckUSBReset

		cpi		ProcessingStatuses,DO_SETUP_DATA
		breq	ProcReceiveSetupData
;***************For setup processes
		cpi	ProcessingStatuses,DO_SETUP_BUFFER_SEPARATION
		breq	ProcPrepareOutSetupBuffer

		cpi		ProcessingStatuses,DO_PS_DATA_SENDER
		breq	ProcContinueSender

		cpi		ProcessingStatuses,DO_PS_DATA_CARD
		breq	ProcPSDataReader

		sbrc	additional_flgs,NESJOY1_NEEDREAD
		rcall	read_nes

		sbrc	additional_flgs,NESJOY2_NEEDREAD
		rcall	read_nes

		sbrc	additional_flgs,SEGAJOY1_NEEDREAD
		rcall	read_sega_1

		sbrc	additional_flgs,SEGAJOY2_NEEDREAD
		rcall	read_sega_2

		sbrc	MainSlotsFlags,JOYA_NEEDREAD
		rcall	ReadJoySticks

		sbrc	AnotherJoyFlags,JOYB_NEEDREAD
		rcall	ReadJoySticks

		rjmp	Main

CheckUSBReset:
		ldi	T00,150		;Reset - as lond as 85us
;		clr	T00		;Reset - as lond as 121us
WaitForUSBReset:
;		sbic	inputport,DMinusChannel	;Waiting for resetting end
;		rjmp	Main
		sbic	inputport,DMinusChannel	;Waiting for resetting end
		rjmp	Main
		dec	T00
		brne	WaitForUSBReset
		rcall	USBReset
		rjmp	Main

ProcPSDataReader:;Make IN ansver to reader
		rcall 	ProcessCardOutPipe
		ldi		ProcessingStatuses,DO_ANSWER_PREPARED 
		rjmp	Main

ProcContinueSender:
		rcall	CompareLongBULKPacket	;Prepare next answer part into separation buffer
		ldi		ProcessingStatuses,DO_ANSWER_PREPARED 
		rjmp	Main

ProcPrepareOutSetupBuffer:
		rcall	PrepareContinuousBuffer	;Prepare next answer part into separation buffer
		ldi		ProcessingStatuses,DO_SETUP_ANSWER_PREPARED 
		rjmp	Main

ProcReceiveSetupData:

		rcall	PrepareUSBAnswer	;Prepare answer for usb host
		ldi		ProcessingStatuses,DO_SETUP_ANSWER_PREPARED;Ansver prepared
		rjmp	Main

USBReset:		;Resetting current device
		ldi	T00,0				;Our device address = 0
		mov	DeviceAddress,T00
		clr	EngineState			;Angine state is base state
		clr	ProcessingStatuses	;No actions in process
		clr	CurrentDataPosition	;Data must be reding from FLASH
		sts ConfigByte,T00


		ldi	T00,0x00
		mov	PSDataSize,T00

	ldi		YH,High(PSREADER_Buffer)		;restore start position of our PSCRAD buffer
	sts		PSDATAHI,YH
	ldi		YL,Low(PSREADER_Buffer)	;restore start position of our PSCRAD buffer
	sts		PSDATALO,YL

;/*Init CARDREADER PIPE Buffer*/
		ldi	T01,DATA1PID
		sts	USB_BulkBuffer,T01

;/*Init JOYSTCKS PIPEs*/
		clr	MainSlotsFlags;no joy data redy
		clr	additional_flgs
		clr	AnotherJoyFlags

		ldi	T01,DATA0PID
		sts	USB_OutPacket,T01;init joy's pid

		sts	NES1DATA,T01;init NES joy 1 pid
		sts	NES2DATA,T01;init NES joy 2 pid
		sts	SEGA1BULK,T01;init SEGA joy 1 pid
		sts	SEGA2BULK,T01;init SEGA joy 2 pid
		sts	USB_JoyABulkBuffer,T01;init PSX joy 1 pid
		sts	USB_JoyBBulkBuffer,T01;init PSX joy 1 pid

		clr		OutEndpoint
		clr		FLAGS
		clr		ByteCount
;		sbi		PortDirector,USB_DATA_RW
;		cbi		OutPutPort,USB_DATA_RW
		ret
