.include "other.inc"
.include "usb.inc"

#ifndef _MEM_INC
#define _MEM_INC

.equ	MAX_HOSTINPacket_Size 	= 0x3+BULK_INPACKET_SIZE
.equ	MAX_HOSTOUTPacket_Size 	= 0x3+BULK_OUTPACKET_SIZE
.equ	MAX_DEVICEPacket_Size	= 0x3+BULK_PACKET_SIZE
.equ	MAX_DEVICEJoy_PSize		= 0x06;
.equ	MAX_DEVICEJoyBulkBuf	= 0x03+0x8;
.equ	MAX_PSREADERBUFFER		= 0x80

;packed for data receiving
.equ	USB_InPacket 		= SRAM_START;size = MAX_Packet_Size
;Temporary buffer
.equ	USB_OutPacket 		= USB_InPacket+MAX_HOSTINPacket_Size;size = MAX_Packet_Size
;For new Devie Address storring
.equ	DeviceAddressSRAM	= USB_OutPacket+BULK_OUTPACKET_SIZE;size = 0x01
;Our bulk packets for transmit
.equ 	BulkPackets			= DeviceAddressSRAM+0x01
;Our out BULK buffer
.equ	USB_BulkBuffer		= BulkPackets+0x01;size = MAX_DEVICEPacket_Size
;Our out BULK buffer
.equ	PSREADER_Buffer		= USB_BulkBuffer+MAX_DEVICEPacket_Size;size = MAX_DEVICEPacket_Size
;Joy data buffer
.equ	USB_JoyABuffer		= PSREADER_Buffer+MAX_PSREADERBUFFER+0x0C 
;Joy 1 crc HI
.equ	USB_JoyABackBuffer	= USB_JoyABuffer+MAX_DEVICEJoy_PSize
;Joy 1 crc LO
.equ	USB_JoyBBackBuffer	= USB_JoyABackBuffer+MAX_DEVICEJoy_PSize
;OutPipeData for write into card and athers
;.equ	USB_OUTPipeData		= USB_JoyBBackBuffer+MAX_DEVICEJoy_PSize
.equ	CARD_FRMHI			=USB_JoyBBackBuffer+MAX_DEVICEJoy_PSize
.equ	CARD_FRMLO			=CARD_FRMHI+0x01
.equ	CARD_CRC8			=CARD_FRMLO+0x01
.equ	CARD_SLOT			=CARD_CRC8+0x01
;ID 1 idle counter
.equ	ID1_IDLE			= CARD_SLOT+0x01
;Joy BulkBuffer
.equ	USB_JoyBBuffer		= ID1_IDLE+0x01
;Joy A BulkBuffer
.equ	USB_JoyABulkBuffer	= USB_JoyBBuffer+MAX_DEVICEJoy_PSize
;Joy B BulkBuffer
.equ	USB_JoyBBulkBuffer	= USB_JoyABulkBuffer+MAX_DEVICEJoyBulkBuf
;Received data size
.equ	ReceiveDataSize		= USB_JoyBBulkBuffer+MAX_DEVICEJoyBulkBuf;size = 0x01
;Data size for sending
.equ	SendingDataSize		= ReceiveDataSize+0x01;size = 0x01
;PS Data WORD HiByte
.equ	PSDATAHI			= SendingDataSize+0x01;size = 0x01
;PS Data WORD LoByte
.equ	PSDATALO			= PSDATAHI+0x01;size = 0x01
;PS Data WORD LoByte
.equ	FORCEDATA			= PSDATALO+0x01;size = 0x03
;Temporary buffer
.equ	TMPBUFFER			= FORCEDATA+0x03;size=0x05
;Store current config number
.equ	ConfigByte			= TMPBUFFER+0x05;size=0x01
;Nes joy 1 bulk buffer
.equ	NES1DATA			= ConfigByte+0x01;size=0x07
;Nes joy 1 tmp buffer
.equ	NESJOY1D			= NES1DATA+0x07;size=0x03
;Nes joy 2 bulk buffer
.equ	NES2DATA			= NESJOY1D+0x03;size=0x07
;Nes joy 2 tmp buffer
.equ	NESJOY2D			= NES2DATA+0x07;size=0x03


;Sega joy 1 bulk buffer
.equ	SEGA1BULK			= NESJOY2D+0x03;size=0x07
;Sega joy 1 tmp buffer
.equ	SEGA1TMP			= SEGA1BULK+0x07;size=0x03
;Sega joy 2 bulk buffer
.equ	SEGA2BULK			= SEGA1TMP+0x03;size=0x07
;Sega joy 2 tmp buffer
.equ	SEGA2TMP			= SEGA2BULK+0x07;size=0x03

.equ	PSDATAWRHI			= SEGA2TMP+0x03
.equ	PSDATAWRLO			= PSDATAWRHI+0x01
.equ	PSWRITER_Buffer		= PSDATAWRLO+0x01
.equ	StackBegin			= RAMEND

#endif
