;*************************************************************************
;**	other.inc, writen by Masyanya (ASDC), r.a.m. factory 02.03.2007
;**	This file consists registers and ports definitions for USB ver. 1.00
;**		flgorithms. ALL RIGHTS RESERVED
;** Using frequency 15MHz :-)
;*************************************************************************

.include "m8515def.inc"

#ifndef _OTHER_INC
#define _OTHER_INC

.def	PRGMP				=R0		;Using for data moving
.def	CurrentDataPosition	=R1		;Current data position for separation buffer
.def	OutEndpoint			=R2		;OUT endpoint number
.def	backupSREG			=R3		;For backup Flag register in interrupt
.def	TotalBytesToSend	=R4		;How many bytes to send
.def	TransmitPart		=R5		;Current number of transmitting part
.def	DeviceAddress		=R6		;Our USB device address
.def	PSCRC8				=R7		;CRC for PS READER
.def	FLAGS				=R8		;Flags for pipe
.def	PSDataSize			=R9		;Size of transmiting buffer 
.def	MainSlotsFlags 		=R10	;This register is not used in our USB algorithm, you can use this register without PUSH/POP
.def	PipeResetCounter	=R11	;This register is not used in our USB algorithm, you can use this register without PUSH/POP
.def	AnotherJoyFlags		=R12	;This register is not used in our USB algorithm, you can use this register without PUSH/POP
;.def	Calc				=R13	;This register is not used in our USB algorithm, you can use this register without PUSH/POP
.def	OUTPErrorCounter	=R14	;Counter for error data in pipe
.def	BulkByteCount		=R15	;Bulk data size

.def	additional_flgs		=R16		;Global flags register
.def	T00					=R17		;Temporary register 1
.def	T01					=R18		;Temporary register 2
.def	T02					=R19		;Temporary register 3
.def	T03					=R20		;Temporary register 4
.def	ProcessingStatuses	=R21		;Consist current process state
.def	ByteCount			=R22		;Number of bytes to send, or number received bytes.
.def	BitInReg			=R23		;posuvny prijimaci register	;ENG;shift receiving register
.def	EngineState			=R24		;Engine status

.equ	InPutPort	=PIND		;Port using	for Input
.equ	OutPutPort	=PORTD		;Port using	for Output
.equ	PortDirector=DDRD		;In/Output Port Director	

;.equ	USB_DATA_RW	  = PD0	;Data Minus Pin
.equ	DMinusChannel = PD2	;Data Minus Pin
.equ	DPlusChannel  = PD3	;Data Plus Pin
;.equ	DINTChannel	  = 0x02	;Interrupt pin, using only for DEBUG

;************Device connect detection masks
.equ	MASK_DEVICE_CONNECTED		=~((1<<DMinusChannel)|(1<<DPlusChannel)) ;Port mask

#endif
