.include "psx_rc.inc"

;*****************Definitions for HAT*****************************
.equ	UP		= 4
.equ	DOWN	= 6
.equ	LEFT	= 7
.equ	RIGHT	= 5

.cseg

HAT_Table:
;	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F
.db 0xF8,0xF0,0xF2,0xF1,0xF4,0xF8,0xF3,0xF8,0xF6,0xF7,0xF8,0xF8,0xF5,0xF8,0xF8,0xF8
;*****************************************************************

ReadJoySticks:
	push	T03
;Make shure our ports is free, while we writing frame we can't use any ports
	mov		T03,MainSlotsFlags
	andi	T03,(1<<CR_SLOT_1)|(1<<CR_SLOT_2)
	breq	SlotsIsFree
	rjmp	SlotsIsBusy
SlotsIsFree:
	push	T02
	push	T01
	push	T00

	push	ZL
	push	ZH
	push	ByteCount
	push	YL
	push	YH
;/*Init PSX device*/
	rcall	PSX_Init_Ports
;------------------------------------------------------------
;/*Activate joy port 1*/
	rcall	ActivateJoyPort1
;/*Scan joy port*/
	;Buffer position to rading data
	ldi	ZL,low(USB_JoyABuffer)
	ldi	ZH,high(USB_JoyABuffer)

	rcall ScanPSX;reading joy data into specifyed buffer
	
	rcall	psx_sendclose;close joy port 1;
;------------------------------------------------------------
;/*Activate joy port 2*/
	rcall	ActivateJoyPort2
;/*Scan joy port*/
	;Buffer position to rading data
	ldi	ZL,low(USB_JoyBBuffer)
	ldi	ZH,high(USB_JoyBBuffer)

	rcall ScanPSX;reading joy data into specifyed buffer
	
	rcall	psx_sendclose;close joy port 1;
;------------------------------------------------------------
	;Compare joy 1 data into T03 
	clr	T03
	ldi	YL,Low(USB_JoyABuffer)
	ldi YH,High(USB_JoyABuffer)

	ldi	ZL,Low(USB_JoyABackBuffer)
	ldi ZH,High(USB_JoyABackBuffer)

	rcall CompareReports

	sbrc T03,JOY_UPDATED
	ori	T03,1<<JOY1_UPDATED
;------------------------------------------------------------
	;Compare joy 2 data into T03 
	cbr	T03,1<<JOY_UPDATED
	ldi	YL,Low(USB_JoyBBuffer)
	ldi YH,High(USB_JoyBBuffer)

	ldi	ZL,Low(USB_JoyBBackBuffer)
	ldi ZH,High(USB_JoyBBackBuffer)

	rcall CompareReports

	sbrc T03,JOY_UPDATED
	ori	T03,1<<JOY2_UPDATED
;------------------------------------------------------------
	;If we have 2 joys data updated prepare twice report
	andi	T03,(1<<JOY1_UPDATED)|(1<<JOY2_UPDATED)
	breq	NoJoyDataUpdated;no one joys data updated
;!!! Ucomment this for use my fast update driver
;	cpi		T03,(1<<JOY1_UPDATED)|(1<<JOY2_UPDATED)
;	breq	TwiceJoyDataUpdated
;	rjmp	NoTwiceJoyDataUpdated
;TwiceJoyDataUpdated:
;	rcall	PrepareTwiceJoyData
;	ldi		T01,1<<JOY_NEEDSEND
;	or		MainSlotsFlags,T01
;!!! Ucomment this for use my fast update driver
;	rjmp	NoJoyDataUpdated
;NoTwiceJoyDataUpdated:
	push	T03
	sbrc	T03,JOY1_UPDATED
	rcall	PrepareJoy1Data
	pop		T03
	sbrc	T03,JOY2_UPDATED
	rcall	PrepareJoy2Data

NoJoyDataUpdated:
	ldi		T01,~(1<<JOYA_NEEDREAD)
	and		MainSlotsFlags,T01
	ldi		T01,~(1<<JOYB_NEEDREAD)
	and		AnotherJoyFlags,T01

	pop		YH
	pop		YL
	pop		ByteCount
	pop		ZH
	pop		ZL
	pop		T00
	pop		T01
	pop		T02
SlotsIsBusy:
	pop		T03
	ret	

ActivateJoyPort1:
;/*Init joy for transmit*/
	sbi DDRA,ATT_1
	nop
	sbi PORTA,ATT_1
	sbi PORTA,CLK
	sbi PORTA,CMD

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
;/*Activate Joy 1*/
	cbi PORTA,ATT_1
	ret

ActivateJoyPort2:
;/*Init joy for transmit*/
	sbi DDRA,ATT_2
	nop
	sbi PORTA,ATT_2
	sbi PORTA,CLK
	sbi PORTA,CMD

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
;/*Activate Joy 1*/
	cbi PORTA,ATT_2
	ret
/*
ReadJoys:

	push	T03
	push	T02
	push	T01
	push	T00

	push	ZL
	push	ZH

	rcall ScanPSX

	PUSH	YH
	PUSH	YL
	PUSH	ByteCount

FillJoyABuffer:

;Is data changed?	
	rjmp CompareReports
;Need for calc CRC16
CRCNewReportReceived:
CRCNoNewReportReceived:
	ldi ByteCount,0x09
	ldi	YL,low(USB_JoyABuffer)
	ldi	YH,high(USB_JoyABuffer)

;Do not calc crc if no changes
	rcall CalcCRC16

	ldi		T01,1<<JOY_NEEDSEND
	or		MainSlotsFlags,T01

;CRCNoNewReportReceived:
	pop	ByteCount
	POP	YL
	POP YH

;/Is new data chescking by CRC/

	rjmp	OUR_psx_sendclose
*/
ScanPSX:

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay

;/* send header */
	ldi		T01,0x01
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay


_FillJoyABuffer:

	ldi		T01,0x42
	rcall	psx_sendbyte
	rcall	psx_delay

; * SCPH-1010(normal pad)
	cpi		T02,0x41
	brne	NoNormalPad
	rjmp	NormalPad
NoNormalPad:

; * SCPH-1110(analog stick : analog mode)
	cpi		T02,0x53
	brne	NoAnalogStick
	rjmp	AnalogStick
NoAnalogStick:

; * SCPH-1150(analog controller) analog mode(LED = red)
	cpi		T02,0x73
	brne	NoAnalogStickRed
	rjmp	AnalogStickRed
NoAnalogStickRed:; No joy detected
NoJoyDetected:
	rcall	FillDigitalSticks
	rcall	FillAnalogSticks
EndOfScan:
	ret


;********************* SCPH-1010(normal pad)**************************
NormalPad:
;		data[2]=SendByte(0x00,1,id,base);
	clr		T01
	rcall	psx_sendbyte
	rcall	psx_delay

	cpi		T02,0x5a
	brne	NoJoyDetected

	rcall	ReadSticksAsAnalog
	rjmp	EndOfScan
;********************* SCPH-1110(analog stick : analog mode)
AnalogStick:
	clr		T01
	rcall	psx_sendbyte
	rcall	psx_delay

	cpi		T02,0x5a
	brne	NoJoyDetected

	rcall	ReadDigitalJoy

	rcall	ReadAnalogSticks
	rjmp	EndOfScan
;********************* SCPH-1150(analog controller) analog mode(LED = red)
AnalogStickRed:
	clr		T01
	rcall	psx_sendbyte
	rcall	psx_delay

	cpi		T02,0x5a
	brne	NoJoyDetected

	rcall	ReadDigitalJoy

	rcall	ReadAnalogSticks
	rjmp	EndOfScan

ReadDigitalJoy:
	rcall	psx_sendbyte
	rcall	psx_delay

	push	ZH
	push	ZL
	com		T02
	swap	T02
	mov		T01,T02
	sbr		T02,0x0F
	cbr		T01,0xF0
	ldi		ZL,Low(HAT_Table<<1)
	ldi		ZH,High(HAT_Table<<1)

	add		ZL,T01
	brcc	NoIncHatPos
	inc		ZH
NoIncHatPos:

	LPM		T01,Z

	pop		ZL
	pop		ZH
	and		T02,T01
	swap	T02
	STD		Z+1,T02
	clr		T01

	rcall	psx_sendbyte
	rcall	psx_delay

	com		T02

	STD		Z+0,T02
	ret

FillDigitalSticks:
	ldi		T02,0x80
	STD		Z+1,T02
	clr		T02
	STD		Z+0,T02
	ret

FillAnalogSticks:
	ldi		T02,0x80
	STD		Z+2,T02
	STD		Z+3,T02
	STD		Z+4,T02
	STD		Z+5,T02
	ret
ReadSticksAsAnalog:
;12bit - buttons
;4bit  - hat
	rcall	psx_sendbyte
	rcall	psx_delay

	com		T02
	mov		T03,T02
	cbr		T02,0xf0
	sbr		T02,0x80
	STD		Z+1,T02

	rcall	psx_sendbyte
	rcall	psx_delay

	com		T02
	STD		Z+0,T02

	ldi		T02,0x80

	sbrc	T03,LEFT
	ldi		T02,0x00

	sbrc	T03,RIGHT
	ldi		T02,0xFF

	STD		Z+4,T02

	ldi		T02,0x80

	sbrc	T03,UP
	ldi		T02,0x00

	sbrc	T03,DOWN
	ldi		T02,0xFF

	STD		Z+5,T02

	ldi		T02,0x80
	STD		Z+3,T02
	STD		Z+2,T02

	ret	
ReadAnalogSticks:
	clr		T01
	rcall	psx_sendbyte
	rcall	psx_delay

	STD		Z+2,T02

	rcall	psx_sendbyte
	rcall	psx_delay

	STD		Z+3,T02

	rcall	psx_sendbyte
	rcall	psx_delay

	STD		Z+4,T02

	rcall	psx_sendbyte
	rcall	psx_delay

	STD		Z+5,T02
	ret

CompareReports:
	ldi T00,0x06

CompareLoop:
	ld	T01,Y+
	ld	T02,Z
	st	Z+,T01
	cpse T01,T02
	rjmp NewDataReceived
	dec	T00
	brne CompareLoop
	andi	T03,~(1<<JOY_UPDATED)
	ret
NewDataReceived:
	dec T00
	breq EndOfCompare
ContinueDataCopy:
	ld	T01,Y+
	st	Z+,T01
	dec	T00
	brne ContinueDataCopy
EndOfCompare:
	ori	T03,1<<JOY_UPDATED
	ret

CopyJoyDataLoop:
	ldi	T00,0x06
ContinueCopy:
	ld	T01,Z+
	st	Y+,T01
	dec	T00
	brne ContinueCopy
	ret
	
;PrepareTwiceJoyData:
;	ldi	YL,Low(USB_JoyBulkBuffer+1)
;	ldi	YH,High(USB_JoyBulkBuffer+1)

;	ldi	ZL,Low(USB_JoyABuffer)
;	ldi	ZH,High(USB_JoyABuffer)

;	ldi	T02,0x01;palace ID 1 for joy 1 report into output buffer
;	st	Y+,T02
;	rcall CopyJoyDataLoop
;	ldi	T02,0x02;palace ID 2 for joy 2 report into output buffer
;	st	Y+,T02
;	ldi	ZL,Low(USB_JoyBBuffer)
;	ldi	ZH,High(USB_JoyBBuffer)
;	rcall CopyJoyDataLoop

;Calculating CRC16 for long USB Buffer
;	ldi	ByteCount,14+2
;	ldi	YL,Low(USB_JoyBulkBuffer)
;	ldi	YH,High(USB_JoyBulkBuffer)
	
;	rcall CalcCRC16
;	ldi	T00,14+2+2
;	mov	JoyDataSize,T00
;	ret
	
PrepareJoy1Data:
	ldi	YL,Low(USB_JoyABulkBuffer+1)
	ldi	YH,High(USB_JoyABulkBuffer+1)

	ldi	ZL,Low(USB_JoyABuffer)
	ldi	ZH,High(USB_JoyABuffer)

	ldi	T02,0x01;palace ID 1 for joy 1 report into output buffer
	st	Y+,T02
	rcall CopyJoyDataLoop

;Calculating CRC16 for long USB Buffer
	ldi	ByteCount,7+2
	ldi	YL,Low(USB_JoyABulkBuffer)
	ldi	YH,High(USB_JoyABulkBuffer)
	
	rcall CalcCRC16
;	ldi	T00,7+2+2
;	mov	JoyDataSize,T00

	ldi		T01,1<<JOYA_NEEDSEND
	or		MainSlotsFlags,T01
	ret

PrepareJoy2Data:
	ldi	YL,Low(USB_JoyBBulkBuffer+1)
	ldi	YH,High(USB_JoyBBulkBuffer+1)

	ldi	ZL,Low(USB_JoyBBuffer)
	ldi	ZH,High(USB_JoyBBuffer)

	ldi	T02,0x01;palace ID 1 for joy 1 report into output buffer
	st	Y+,T02
	rcall CopyJoyDataLoop

;Calculating CRC16 for long USB Buffer
	ldi	ByteCount,7+2
	ldi	YL,Low(USB_JoyBBulkBuffer)
	ldi	YH,High(USB_JoyBBulkBuffer)
	
	rcall CalcCRC16
;	ldi	T00,7+2+2
;	mov	JoyDataSize,T00

	ldi		T01,1<<JOYB_NEEDSEND
	or		AnotherJoyFlags,T01
	ret

ScanSendFeedback:

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay

;/* send header */
	ldi		T01,0x01
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay

	ldi		T01,0x42
	rcall	psx_sendbyte
	rcall	psx_delay

	ldi		T01,0x00
	rcall	psx_sendbyte
	rcall	psx_delay

	ldi		T01,0x55//Fedback First
	rcall	psx_sendbyte
	rcall	psx_delay

	ldi		T01,0xAA//Fedback Second
	rcall	psx_sendbyte
	rcall	psx_delay

	ldi		T01,0x01
	rcall	psx_sendbyte
	rcall	psx_delay

	ldi		T01,0x00
	rcall	psx_sendbyte
	rcall	psx_delay

	rcall	psx_sendclose	;close opened port
	ret						;and return

CopyFFData:
	;**
	;** Copy our feedback data
	;**
	lds		T01,USB_InPacket+1;load command
	STS		FORCEDATA,T01	
	lds		T01,USB_InPacket+2;load param 1
	STS		FORCEDATA+1,T01	
	lds		T01,USB_InPacket+3;load param 2
	STS		FORCEDATA+2,T01	
	ret
ForceFeedback_1:
;	rcall	CopyFFData
	;Move pointer to FF Init data
	ldi		ZH,High(ForceCommands_1<<1)
	ldi		ZL,Low(ForceCommands_1<<1)
;Send first string
	rcall	PSX_Init_Ports
	rcall	ActivateJoyPort1
	ldi		T01,1<<CR_SLOT_1
	ldi		T03,0x06
	rcall	psx_sendstring
;Send second string
	rcall	ActivateJoyPort1
	ldi		T01,1<<CR_SLOT_1
	ldi		T03,0x0a
	rcall	psx_sendstring
;Send third string
	rcall	ActivateJoyPort1
	ldi		T01,1<<CR_SLOT_1
	ldi		T03,0x0a
	rcall	psx_sendstring
	
	rcall	ActivateJoyPort1
	ldi		T01,1<<CR_SLOT_1
	ldi		T03,0x06
	rcall	psx_sendstring

	ldi		T01,~(1<<CR_SLOT_1)
	and		MainSlotsFlags,T01
	ret		
ForceFeedback_2:
	;**
	;** Copy our feedback data
	;**
	rcall	CopyFFData
	;Move pointer to FF Init data
	ldi		ZH,High(ForceCommands_1<<1)
	ldi		ZL,Low(ForceCommands_1<<1)
;Send first string
	rcall	PSX_Init_Ports
	rcall	ActivateJoyPort2
	ldi		T01,1<<CR_SLOT_2
	rcall	psx_sendstring
;Send second string
	rcall	ActivateJoyPort2
	ldi		T01,1<<CR_SLOT_2
	rcall	psx_sendstring
;Send third string
	rcall	ActivateJoyPort2
	ldi		T01,1<<CR_SLOT_2
	rcall	psx_sendstring
	
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	ActivateJoyPort2
	ldi		T01,1<<CR_SLOT_2
	rcall	psx_sendstring
;	ldi		T01,~(1<<CR_SLOT_1)
;	and		MainSlotsFlags,T01
	ret		

ForceCommands_1:
	.db		0x01, 0x43, 0x00, 0x01, 0x00, 0x01//6
	.db		0x01, 0x4d, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x01//10
	.db		0x01, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01//10
ForceCommands_2:
	.db		0x01, 0x42, 0x00, 0x55, 0xAA, 0x01//6

psx_sendstring:
	rcall	PSX_Init_Ports
	rcall	psx_sendinit

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
ForceLoop:
	LPM		T01, Z+		;Load single byte
	cpi		T01,0x55	;Is end of string?
	brne	NoProcessCommand_0
	lds		T01,FORCEDATA+2
	rjmp	OutOfProcess
NoProcessCommand_0:
	cpi		T01,0xAA	;Is end of string?
	brne	OutOfProcess
	lds		T01,FORCEDATA+3
OutOfProcess:
	rcall	psx_sendbyte;Send Loaded byte
	rcall	psx_delay	;Wait
	rcall	psx_delay	;Wait
;	LPM		T01, Z		;Load again 
;	cpi		T01,0x55	;Is end of string?
	dec		T03
	brne	ForceLoop
;	ADIW	ZH:ZL,0x01
	rcall	psx_sendclose
	ret

