
;.IFNDEF USED_INVERTER
;.equ	USED_INVERTER	=0x01
;.ENDIF

.cseg
;*********************************************************************
;Process our pipe card frame, 128 R/W BYTES
;*********************************************************************
;*********************************************************************
;Read PSX card frame, 128 BYTES
;*********************************************************************
psx_memcard_read_frame:
	lds		T01,USB_InPacket+2; USB_OUTPipeData+2;Send HIBYTE
	sts		CARD_FRMHI,T01
	lds		T01,USB_InPacket+3; USB_OUTPipeData+3;Send LOBYTE
	sts		CARD_FRMLO,T01

;/*Init our data buffer*/
	ldi		ZH,High(PSREADER_Buffer)
	sts		PSDATAHI,ZH
	ldi		ZL,Low(PSREADER_Buffer)
	sts		PSDATALO,ZL
;/*Init PSX device*/
	rcall	PSX_Init_Ports
	lds		T01,CARD_SLOT
	rcall	psx_sendinit

	or		MainSlotsFlags,T01
;/* send header */
	ldi		T01,0x81
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

;	STS		PSREADER_Buffer,T02

	rcall	psx_delay
	rcall	psx_delay

	ldi		T01,0x52
	rcall	psx_sendbyte

;	STS		PSREADER_Buffer+1,T02

	rcall	psx_delay
	rcall	psx_delay

;**************And check first***********
	clr		T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
	
	cpi		T02,0x5A
	breq	_OKCHECKFIRST

;	clr		PSDataSize

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_NOCARD
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
_OKCHECKFIRST:
;**************And check second***********
	rcall	psx_sendbyte

	cpi		T02,0x5D
	breq	_OKCHECKSECOND

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_NOCARD
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
_OKCHECKSECOND:

	rcall	psx_delay
	rcall	psx_delay
;**************send read address**********
;	PSXREAD
	lds		T01,CARD_FRMHI; USB_OUTPipeData+1;Send HIBYTE
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	lds		T01,CARD_FRMLO;	USB_OUTPipeData+2;Send LOBYTE
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

; receive command ack (have to wait for this) 
	clr		T01
	rcall	psx_sendbyte

	cpi		T02,0x5C
	breq	_OKWAITING

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_NOCMDACK
	rjmp	CompareLastError	

;	rcall	Card_psx_sendclose
_OKWAITING:
;  receive start of data flag 
	clr		T03
	clr		T01
chk_rstring_sfl:
	rcall	psx_delay

	rcall	psx_sendbyte

	rcall	psx_delay

	cpi		T02,0x5D
	breq	EndOfWaitingDataFlag

	dec		T03; -  ...  ..   ....
	brne	_NOSTANDWAITING

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_WAIT
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
_NOSTANDWAITING:
	rjmp	chk_rstring_sfl
EndOfWaitingDataFlag:

; receive read address 
	clr		T01
	rcall	psx_sendbyte
	rcall	psx_delay
;Compare our address HIBYTE and received by memory address
	clr		PSCRC8
	eor		PSCRC8,T02;For CRC
	lds		T00,CARD_FRMHI;	USB_OUTPipeData+1
	cp		T02,T00
	breq	_OKHIBYTE	

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_ADDRH
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
_OKHIBYTE:
	rcall	psx_delay
	rcall	psx_delay

	rcall	psx_sendbyte
	rcall	psx_delay
;Compare our address LOBYTE and received by memory address
	eor		PSCRC8,T02;For CRC
	lds		T00,CARD_FRMLO;	USB_OUTPipeData+1
	cp		T02,T00
	breq	_OKLOBYTE

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_ADDRL
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
_OKLOBYTE:
; receive data 
	ldi		T03,MAX_PSREADERBUFFER
	
	ldi		ZL,Low(PSREADER_Buffer)
	ldi		ZH,High(PSREADER_Buffer)

	clr		T01
READPS_Data_Loop:
	rcall	psx_sendbyte
	rcall	psx_delay

	eor		PSCRC8,T02;For CRC

	st		Z+,T02

	dec		T03
	brne	READPS_Data_Loop

	rcall	psx_sendbyte

	cp		PSCRC8,T02
	breq	DataCRCOK
;DATA Receiving error by CRC
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_CRC
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose
DataCRCOK:

; receive end of data flag 
	rcall	psx_sendbyte
	cpi		T02,0x47
	breq	EndOfDataOK

;DATA Receiving error by END OF DATA
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_EOD
	rjmp	CompareLastError	

;	rjmp	Card_psx_sendclose

EndOfDataOK:
	rcall	psx_delay
;Reinit PS Data Buffer for Sending onto USB
	ldi		T00,0x80
	mov		PSDataSize,T00


	;Prepare READER Buffer for data transmit
	ldi		ZH,High(PSREADER_Buffer)
	ldi		ZL,Low(PSREADER_Buffer)

	sts		PSDATAHI,ZH
	sts		PSDATALO,ZL

	;clear used slots
	rcall	Card_psx_sendclose
	ldi		T01,~((1<<CR_SLOT_1)|(1<<CR_SLOT_2))
	and		MainSlotsFlags,T01

	rcall	CompareInDataPacket

	rjmp	CardReadEndClose
OUR_psx_sendclose:
	rcall	psx_sendclose
CardReadEndClose:
	pop		YH
	pop		YL	

	pop		ZH
	pop		ZL	

	pop		T00
	pop		T01
	pop		T02
	pop		T03
	ret

Card_psx_sendclose:
	rcall	psx_sendclose
	ret		

;*********************************************************************
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte
;*********************************************************************
psx_sendbyte:
	ldi		T00,0x08;Size of byte in bits = 8
.IFDEF USED_INVERTER
	cbi		PORTA,CLK;Set clock HIGH
.ELSE
	sbi		PORTA,CLK;Set clock HIGH
.ENDIF	
Sending_Byte_Loop:

	rcall	psx_delay

;***************Sending BYTE*******************	
	lsr		T01;shift LSB bit into CARRY flag
	BRCC	PSXSetZeroBit
.IFDEF USED_INVERTER
	cbi		PORTA,CMD;LSB bit = ONE
.ELSE
	sbi		PORTA,CMD;LSB bit = ONE
.ENDIF	
	rjmp	PSXSettingOneBit
PSXSetZeroBit:
.IFDEF USED_INVERTER
	sbi		PORTA,CMD;LSB bit = ONE
.ELSE
	cbi		PORTA,CMD;LSB bit = ZERO
.ENDIF	
PSXSettingOneBit:

.IFDEF USED_INVERTER
	sbi		PORTA,CLK;Set clock LOW
.ELSE
	cbi		PORTA,CLK;Set clock LOW
.ENDIF	

	rcall	psx_delay



;***************Receiving BYTE*******************	
	CLC;Clear carry flag
.IFDEF USED_INVERTER
	sbis	PINA,DATA ; if DATA port go high set carry flag
.ELSE
	sbic	PINA,DATA ; if DATA port go high set carry flag
.ENDIF	
	SEC;Set carry flag
	ror		T02;Store carry flag is data bit into T02 register 
;***************End Our loop*********************
.IFDEF USED_INVERTER
	cbi		PORTA,CLK;Set clock HIGH
.ELSE
	sbi		PORTA,CLK;Set clock HIGH
.ENDIF	

	dec		T00
	breq	WaitForACK
	rjmp	Sending_Byte_Loop
	
;wait ACK ower 60 us = 900 cycles, T0 = 900/6
WaitForACK:
	ldi		T00,10;//900/6


WaitForACK_Loop:
	rcall	psx_delay

.IFDEF USED_INVERTER
	sbis	PINA,ACK	;1 cycle - false 2 cycle - true
.ELSE
	sbic	PINA,ACK	;1 cycle - false 2 cycle - true
.ENDIF	
	rjmp	EndACKWaiting;2 cycle Then go LOW we end waiting

	dec		T00			;1 cycle
	breq	psx_sendclose_and_exit ;1 cycle - false 2 cycle - true

	rjmp	WaitForACK_Loop	;2 cycle
EndACKWaiting:
	ret
psx_sendclose_and_exit:
;	dec		T01
;	brne	WaitForACK_Loop ;1 cycle - false 2 cycle - true

	ret
;	pop		T00;pop up LOBYTE byte return addr
;	pop		T00;pop up HIBYTE byte return addr
;	rjmp	OUR_psx_sendclose

;*********************************************************************
;No params
;*********************************************************************
psx_sendinit:
.IFDEF USED_INVERTER
	cbi		PORTA,CLK
	cbi		PORTA,CMD
	cbi		PORTA,ATT_1;Set ATT to LOW
	cbi		PORTA,ATT_2;Set ATT to LOW
.ELSE
	sbi		PORTA,CLK
	sbi		PORTA,CMD
	sbi		PORTA,ATT_1;Set ATT to LOW
	sbi		PORTA,ATT_2;Set ATT to LOW
.ENDIF	


	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	andi	T01,(1<<CR_SLOT_1)|(1<<CR_SLOT_2)
	breq	ErrorCommandParams
	cpi		T01,(1<<CR_SLOT_1)|(1<<CR_SLOT_2)
	breq	ErrorCommandParams

	sbrc	T01,CR_SLOT_2
.IFDEF USED_INVERTER
	sbi		PORTA,ATT_2;Set ATT to LOW
.ELSE
	cbi		PORTA,ATT_2;Set ATT to LOW
.ENDIF	
	sbrc	T01,CR_SLOT_1
.IFDEF USED_INVERTER
	sbi		PORTA,ATT_1;Set ATT to LOW
.ELSE
	cbi		PORTA,ATT_1;Set ATT to LOW
.ENDIF	
	or		MainSlotsFlags,T01
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	ret
ErrorCommandParams:
	pop		T00
	pop		T00

;Set ERROR flag to out pipe
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_PARAMS
	LDS		T02,CARD_SLOT
	ldi		T03,0x01
	rjmp	CompareLastError	

;	rjmp	OUR_psx_sendclose

;*********************************************************************
; * use after psx_sendbyte()
;*********************************************************************
psx_sendclose:
	rcall	psx_delay
	rcall	psx_delay
.IFDEF USED_INVERTER
	cbi		PORTA,ATT_1; /* set att on for conport */
	cbi		PORTA,ATT_2; /* set att on for conport */
	cbi		PORTA,CMD; /* set command on for conport */
	cbi		PORTA,CLK; /* clock high */
.ELSE
	sbi		PORTA,ATT_1; /* set att on for conport */
	sbi		PORTA,ATT_2; /* set att on for conport */
	sbi		PORTA,CMD; /* set command on for conport */
	sbi		PORTA,CLK; /* clock high */
.ENDIF	
	rcall	psx_delay
	ret

PSX_Init_Ports:
	ldi		T00,(1<<ATT_1)|(1<<ATT_2)|(1<<CMD)|(1<<CLK)
	out		DDRA,T00
	ret

;*********************************************************************
;4us = 60 cycles
;*********************************************************************
psx_delay:
	push	T03;4 cycles
	ldi		T03,0x16;1 cycle
WaitLoop:
	dec		T03;1 cycle
	nop
	brne	WaitLoop
	pop		T03
	ret

;*********************************************************************
;OUT pipe processing funcs
;*********************************************************************
ReadDeviceState:
	rjmp	_ReadDeviceState
	
ReadCardFrame:
	rjmp	psx_memcard_read_frame

ProcessCardOutPipe:
	push	T03
	push	T02
	push	T01
	push	T00

	push	ZL
	push	ZH

	push	YL
	push	YH

;	ldi	ZH,High(USB_InPacket+1)
;	ldi	ZL,Low(USB_InPacket+1)

	LDS	T01,USB_InPacket+1
	STS	USB_InPacket,T01

	STS		CARD_SLOT,T01
	andi	T01,~((1<<CR_SLOT_1)|(1<<CR_SLOT_2))

	sbrc	T01,READ_CARDFRAME 
	rjmp	ReadCardFrame

	sbrc	T01,READ_DEVSTATE 
	rjmp	ReadDeviceState

	sbrc	T01,WRITE_START 
	rjmp	WriteStart

	sbrc	T01,WRITE_CONTINUE 
	rjmp	WriteContinue

	sbrc	T01,WRITE_LAST 
	rjmp	WriteLast

	sbrc	T01,RW_ABORT 
	rjmp	_RW_Abort

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_UNK_CMD
	rjmp	CompareLastError	
WriteContinue_:
	rjmp	WriteContinue
WriteLast_:
	rjmp	WriteLast
_RW_Abort_:
	rjmp	_RW_Abort
;---------------------------------------------------------------------
CopyDataLoop:
	ld	T00,Y+
	st	Z+,T00
	dec	T01
	brne CopyDataLoop

	;save data pos in buffer
	sts	PSDATAWRHI,ZH
	sts	PSDATAWRLO,ZL
	ret

WriteStart:
;Copy to data buffer our receive data
	lds	T01,ReceiveDataSize
	subi T01,0x06

;restore "NULL" data position
	ldi		ZH,High(PSWRITER_Buffer)
	sts		PSDATAWRHI,ZH

	ldi		ZL,Low(PSWRITER_Buffer)
	sts		PSDATAWRLO,ZL

	ldi	YH,High(USB_InPacket+2)
	ldi	YL,Low(USB_InPacket+2)

;Store card frame pos HI
	ld	T00,Y+
	sts CARD_FRMHI,T00

;Store card frame pos LO
	ld	T00,Y+
	sts CARD_FRMLO,T00
	
	rcall CopyDataLoop

	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ALL_OK
	rjmp	CompareLastError	
;---------------------------------------------------------------------
SendWriteHeader:
;/* send header */
	ldi		T01,0x81
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	ldi		T01,0x57
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	clr		T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	cpi		T02,0x5A
	brne	ErrorWriteInit

	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	cpi		T02,0x5D
	brne	ErrorWriteInit

	ret
ErrorWriteInit:
;SetWrite error flag
	pop		T00
	pop		T00

;Set ERROR flag to out pipe
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_PARAMS
	ldi		T03,0x02
	rjmp	CompareLastError	

;	rjmp	OUR_psx_sendclose

WriteContinue:
;Copy to data buffer our receive data
;	cli
	;Occupy main IN PIPES buffer
;	ldi	T01,IN_PIPE_BCOPYED
;	or MainSlotsFlags,T01

	lds	T01,ReceiveDataSize
	subi T01,0x04
	lds	ZH,PSDATAWRHI
	lds	ZL,PSDATAWRLO
	ldi	YH,High(USB_InPacket+2)
	ldi	YL,Low(USB_InPacket+2)

	rcall CopyDataLoop

	;Release main IN PIPES buffer
;	ldi	T01,~IN_PIPE_BCOPYED
;	and MainSlotsFlags,T01

;	clr		ProcessingStatuses
;	rjmp	CardReadEndClose
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ALL_OK
	rjmp	CompareLastError	


Clear_ERROR_flag:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_PARAMS
	ldi		T03,0x03
	rjmp	CompareLastError
;	rjmp	OUR_psx_sendclose	

_RW_Abort:
;	mov		T01,MainSlotsFlags
;	andi	T01,~(1<<ERROR_FLAG)
;	mov		MainSlotsFlags,T01

__RW_Abort:
	ldi		T01,~((1<<CR_SLOT_1)|(1<<CR_SLOT_2))
	and		MainSlotsFlags,T01

;restore "NULL" data position
	ldi		T00,High(PSREADER_Buffer)
	sts		PSDATAHI,T00

	ldi		T00,Low(PSREADER_Buffer)
	sts		PSDATALO,T00

	rjmp	OUR_psx_sendclose
	
WriteLast:
;Copy to data buffer our receive data
;	cli
	;Occupy main IN PIPES buffer
;	ldi	T01,IN_PIPE_BCOPYED
;	or MainSlotsFlags,T01

	lds	T01,ReceiveDataSize
;	ldi	T01,0x0A
	subi T01,0x05

	ldi	YH,High(USB_InPacket+2)
	ldi	YL,Low(USB_InPacket+2)

	lds	ZH,PSDATAWRHI
	lds	ZL,PSDATAWRLO

	rcall CopyDataLoop

	ld	T00,Y+
	sts CARD_CRC8,T00

WriteDataIntoCard:

	ldi		ZH,High(PSWRITER_Buffer)
	sts		PSDATAWRHI,ZH

	ldi		ZL,Low(PSWRITER_Buffer)
	sts		PSDATAWRLO,ZL


	lds		T01,CARD_SLOT
	rcall	PSX_Init_Ports
	rcall	psx_sendinit

;	Set Write in progress 
;	andi	T01,(1<<CR_SLOT_1)|(1<<CR_SLOT_2)
	or		MainSlotsFlags,T01

;Number of bytes to write into T00 = 29	
	rcall	SendWriteHeader

	clr		PSCRC8
	lds		T01,CARD_FRMHI;HIBYTE(wWriteAddress)
	eor		PSCRC8,T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	lds		T01,CARD_FRMLO;LOBYTE(wWriteAddress)
	eor		PSCRC8,T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	lds		T01,CARD_FRMHI;HIBYTE(wWriteAddress)
	cp		T02,T01
	brne	WriteAddrErrorH;Wrong HIBYTE of address

	ld		T01,Z;dt0
	eor		PSCRC8,T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	lds		T01,CARD_FRMLO;LOBYTE(wWriteAddress)
	cp		T02,T01
	brne	WriteAddrErrorL;Wrong LOBYTE of address

	ldi		T03,0x80-1;sizeof frame in bytes

;Write received data into card
WriteCardData:
	ldd	T01,Z+1
	eor	PSCRC8,T01

	rcall	psx_delay

	rcall	psx_sendbyte

	rcall	psx_delay

	ld		T01,Z+
;8888
	cp		T02,T01
	brne	DTWRWriteError_

	dec T03
	brne WriteCardData

	lds		T01,CARD_CRC8
	cp		PSCRC8,T01
	brne	CRCWriteError

	mov		T01,PSCRC8
	rcall	psx_delay
	rcall	psx_sendbyte

	ld		T01,Z
	cp		T02,T01
	brne	DTWRWriteError

	rjmp	WriteALLOK

DTWRWriteError_:
	rjmp	DTWRWriteError

WriteAddrErrorH:
;Set ERROR flag to out pipe
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_ADDRH
	rjmp	CompareLastError	

;	rjmp	OUR_psx_sendclose
WriteAddrErrorL:
;Set ERROR flag to out pipe
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_ADDRL
	rjmp	CompareLastError	

;	rjmp	OUR_psx_sendclose
WriteALLOK:

	clr		T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	cpi		T02,0x5C
	brne	EODAWriteError

	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	cpi		T02,0x5D
	brne	EODBWriteError

	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay

	cpi		T02,0x47
	brne	EODWriteError


;end mark      	 end flag   	     end flag(error)
;    |--------|--------|	|--------|		|--------|
;CMD |   00h  |   00h  |	|   00h  |		|   00h  |
;    |--------|--------|	|--------|		|--------|
;DAT | 5Ch '\'| 5Dh ']'|	| 47h 'G'|		| 4Eh 'N'|
;    |--------|--------|	|--------|		|--------|
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ALL_OK
	rjmp	CompareLastError
;	rjmp	_RW_Abort
DTWRWriteError:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_DTWR
	rjmp	CompareLastError
;	rjmp	__RW_Abort
EODWriteError:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_EOD
	rjmp	CompareLastError
;	rjmp	__RW_Abort
		
CRCWriteError:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_CRC
	rjmp	CompareLastError
;	rjmp	__RW_Abort

EODAWriteError:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_EODA
	rjmp	CompareLastError
;	rjmp	__RW_Abort

EODBWriteError:
	ldi		T00,RETURN_CARDSTATE
	ldi		T01,ERROR_EODB
	rjmp	CompareLastError
;	rjmp	__RW_Abort

_psx_detect_card_on_slot:
;/* send header */
	ldi		T01,0x81
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
;------------------------------------------------------------------------
	ldi		T01,0x52
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
;------------------------------------------------------------------------
;**************And check first***********
	clr		T01
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
	
	cpi		T02,0x5A
	brne	NOCHECKCARD

;**************And check second***********
	rcall	psx_sendbyte
	
	cpi		T02,0x5D
	brne	NOCHECKCARD

	ldi		T03,0x01
	ret		
NOCHECKCARD:
	clr		T03
	ret		
;----------------------------------------------------------------------
_psx_detect_joy_on_slot:

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay

;/* send header */
	ldi		T01,0x01
;BYTE psx_sendbyte(BYTE T01) - C like prototype
;Insert T01 - Sending BYTE
;Rerurn T02 - Received byte	rcall	psx_sendbyte
	rcall	psx_sendbyte

	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay
	rcall	psx_delay

	ldi		T01,0x42
	rcall	psx_sendbyte
	rcall	psx_delay
	ret
;----------------------------------------------------------------------
_ReadDeviceState:
	clr		PSDataSize
;Makeup port director
	ldi		ZH,High(PSREADER_Buffer)
	ldi		ZL,Low(PSREADER_Buffer)
;-------------------Try Detect card on slot 1------------------------------
	rcall	PSX_Init_Ports
;Activate port slot 1
	ldi		T01,1<<CR_SLOT_1
	rcall	psx_sendinit
	rcall	_psx_detect_card_on_slot
	st		Z+,T03
	rcall	psx_sendclose;close our opened port
;-------------------Try Detect card on slot 2------------------------------
	rcall	PSX_Init_Ports
;Activate port slot 1
	ldi		T01,1<<CR_SLOT_2
	rcall	psx_sendinit
	rcall	_psx_detect_card_on_slot
	st		Z+,T03
	rcall	psx_sendclose;close our opened port
;-------------------Try Detect joy on slot 1------------------------------
	rcall	PSX_Init_Ports
;Activate port slot 1
	rcall	ActivateJoyPort1
	rcall	_psx_detect_joy_on_slot
	st		Z+,T02
	rcall	psx_sendclose;close our opened port
;-------------------Try Detect joy on slot 2------------------------------
	rcall	PSX_Init_Ports
;Activate port slot 1
	rcall	ActivateJoyPort2
	rcall	_psx_detect_joy_on_slot
	st		Z+,T02
	rcall	psx_sendclose;close our opened port
;------------------------------------------------------------------
;	clr		ProcessingStatuses

	;clear used slots
	rcall	Card_psx_sendclose
	ldi		T01,~((1<<CR_SLOT_1)|(1<<CR_SLOT_2))
	and		MainSlotsFlags,T01

	ldi		ZH,High(PSREADER_Buffer)
	sts		PSDATAHI,ZH
	ldi		ZL,Low(PSREADER_Buffer)
	sts		PSDATALO,ZL

	ldi		T01,0x04
	mov		PSDataSize,T01
	rcall	CompareInDataPacket
	
	rjmp	CardReadEndClose

CompareLastError:
;Set error info
	clr		PSDataSize
	STS		PSREADER_Buffer,T00
	STS		PSREADER_Buffer+1,T01
	STS		PSREADER_Buffer+2,T02
	STS		PSREADER_Buffer+3,T03

;Set size of error report
	inc		PSDataSize
	inc		PSDataSize
	inc		PSDataSize
	inc		PSDataSize
;Compare packet

	ldi		ZH,High(PSREADER_Buffer)
	ldi		ZL,Low(PSREADER_Buffer)

	sts		PSDATAHI,ZH
	sts		PSDATALO,ZL

	clr		ProcessingStatuses

	;clear used slots
	rcall	Card_psx_sendclose

	ldi		T01,~((1<<CR_SLOT_1)|(1<<CR_SLOT_2))
	and		MainSlotsFlags,T01

	rcall	CompareInDataPacket

	rjmp	CardReadEndClose		

CompareInDataPacket:
	PUSH	ByteCount
	push	YH
	push	YL
	rcall	CompareLongBULKPacket
	pop		YL
	pop		YH
	POP		ByteCount
	ldi		ProcessingStatuses,DO_ANSWER_PREPARED
	ret
