;If we used 74f04,74f14,74f06 define this if used 74f07 comment this string
;Pipe commands
.equ	READ_DEVSTATE	=0x00  ;Read the device status 
.equ	READ_CARDFRAME	=0x01  ;Read frame from card 
.equ	WRITE_START		=0x02  ;Open card slot and starting write frame into card. 
.equ	WRITE_CONTINUE	=0x03  ;Suspend writing into card. 
.equ	WRITE_LAST		=0x04 ;Writing last frame into card, and close card slot. 
.equ	RW_ABORT		=0x05 ;Abort all read/write operations 
.equ	CR_SLOT_1		=0x06
.equ	CR_SLOT_2		=0x07

;falags for compare joys data
.equ	JOY_UPDATED		=0x00
.equ	JOY1_UPDATED	=0x01
.equ	JOY2_UPDATED	=0x02
;Another flags
.equ	JOYB_NEEDSEND	= 0x00
.equ	JOYB_NEEDREAD	= 0x01
;Joy data ready flags
.equ	JOYA_NEEDSEND	= 0x00
.equ	JOYA_NEEDREAD	= 0x01
.equ	JOY1_FORCE		= 0x04
.equ	JOY2_FORCE		= 0x05
;Additional joys flags
.equ	NESJOY1_NEEDSEND	= 0x00
.equ	NESJOY1_NEEDREAD	= 0x01
.equ	NESJOY2_NEEDSEND	= 0x02
.equ	NESJOY2_NEEDREAD	= 0x03
.equ	SEGAJOY1_NEEDSEND	= 0x04
.equ	SEGAJOY1_NEEDREAD	= 0x05
.equ	SEGAJOY2_NEEDSEND	= 0x06
.equ	SEGAJOY2_NEEDREAD	= 0x07
;External Vibration params from Application
.equ	INIT_VIBRATION			=0x01
.equ	SEND_VIBRATION_PARAMS	=0x02

;In Pipe commands
.equ	RETURN_DEVSTATE	=0xA5  ;Device now return dev state
.equ	RETURN_CARDSTATE=0xAA  ;Device now return card read/write status
;In Pipe return flags from OUT pipe
.equ	ALL_OK			=0x00  ;Opperation complite with no errors
.equ	ERROR_NOCARD	=-0x01  ;Card not present in slot
.equ	ERROR_ADDRH		=-0x02  ;Address HIBYTE check return error
.equ	ERROR_ADDRL		=-0x03  ;Address LOBYTE check return error
.equ	ERROR_PARAMS	=-0x04  ;Invalid params in out pipe
.equ	ERROR_CRC		=-0x05  ;ERROR XOR CRC Copare
.equ	ERROR_NOCMDACK	=-0x06	;0x57 Command acknowloge not reveived
.equ	ERROR_WAIT		=-0x07	;Wait error after 0x57
.equ	ERROR_EOD		=-0x08	;Doe's not receive 0x47 after send command
.equ	ERROR_EODA		=-0x09	//;Wait error after 0x5C  after send command
.equ	ERROR_EODB		=-0x0A	//;Doe's not receive 0x5D after send command
.equ	ERROR_DTWR		=-0x0B	//;Doe's not receive previous data from write
.equ	ERROR_UNK_CMD	=-0x0C	//;Unknown command for data writer
.equ	ERROR_OUT_PIPE	=-0x0D	//;Error in out pipe


;Interface pin definitions
;ATT select, this pin for memcard/joy port 1
.equ	ATT_1	= PA2
;ATT select, this pin for memcard/joy port 2
.equ	ATT_2	= PA3
;Clock
.equ	CLK		= PA4
;Acknowledge
.equ	ACK		= PA5
;Command
.equ	CMD		= PA1
;Data
.equ	DATA	= PA0

.eseg

ReportDescriptor:

.db 0x05, 0x01	; USAGE_PAGE (Generic Desktop)
.db 0x09, 0x04	; USAGE (Joystick)
	.db 0xa1, 0x01	; COLLECTION (Application)
		.db 0xa1, 0x01	; COLLECTION (Logical)
		.db 0x85, 0x01	; REPORT_ID (1)
		.db 0x75, 0x01	; REPORT_SIZE (1)
		.db 0x15, 0x00	; LOGICAL_MINIMUM (0)
		.db 0x35, 0x00	; PHYSICAL_MINIMUM (0)
		.db 0x09, 0x01	;USAGE (Pointer)
		.db 0x95, 0x0C	;REPORT_COUNT (12)
		.db 0x05, 0x09	;USAGE_PAGE (Button)
		.db 0x19, 0x01	;USAGE_MINIMUM (Button 1)
		.db 0x29, 0x0C	;USAGE_MAXIMUM (Button 12)
		.db 0x81, 0x02	;INPUT (Data,Var,Abs)
		.db 0x95, 0x01	;REPORT_COUNT (1)
		.db 0x75, 0x04	;REPORT_SIZE (4)
		.db 0x25, 0x07	;LOGICAL_MAXIMUM (7)
		.db 0x46, 0x3b, 0x01;PHYSICAL_MAXIMUM (315)
		.db 0x66, 0x14, 0x00;UNIT (Eng Rot:0x114)
		.db 0x05, 0x01	;USAGE_PAGE (Generic Desktop)
		.db 0x09, 0x39	;USAGE (Hat switch)
		.db 0x81, 0x42	;INPUT (Data,Var,Abs,Null)
		.db 0x95, 0x04	;REPORT_COUNT (5)
		.db 0x75, 0x08	;REPORT_SIZE (8)
		.db 0x26, 0xff, 0x00 ;LOGICAL_MAXIMUM (255)
		.db 0x46, 0xff, 0x00 ;PHYSICAL_MAXIMUM (255)
		.db 0x09, 0x32	;USAGE (Z)
		.db 0x09, 0x35	;USAGE (Rz)
		.db 0x09, 0x30	;USAGE (X)
		.db 0x09, 0x31	;USAGE (Y)
		.db 0x81, 0x02	;INPUT (Data,Var,Abs)
	.db 0xc0			;END_COLLECTION
.db 0xc0				;END_COLLECTION
EndOfReportDescriptor:

NESReportDescriptor:
        .db	0x05,0x01			;USAGE_PAGE (Generic Desktop)
        .db	0x09,0x04			;USAGE (Joystick)
        .db	0xA1,0x01				;COLLECTION (Application)
        .db 0x09,0x01				;USAGE (Pointer)
        .db 0xA1,0x00              	;COLLECTION (Physical)
		.db 0x85,0x01						;Report_ID (1)
		.db 0x09,0x30						;Usage (X) - OK
		.db 0x09,0x31						;Usage (Y) - OK
        .db 0x15,0x81                		;LOGICAL_MINIMUM (-7)
        .db 0x25,0x7f                		;LOGICAL_MAXIMUM (7)
		.db 0x75,0x08						;Report_Size (8)
		.db 0x95,0x02						;Report_Count (1)
		.db 0x81,0x02						;Input (Data, Var, Abs)
		.db 0x15,0x00						;Logical_Minimum (0)
		.db 0x25,0x01						;Logical Maximum (1)
		.db 0x95,0x08						;Report_Count (8)
		.db 0x75,0x01						;Report_Size (1)
		.db 0x05,0x09						;Usage_Page (Button)
		.db 0x19,0x01						;Usage_Minimum (Button 1)
		.db 0x29,0x04						;Usage_Maximum (Button 8)
		.db 0x81,0x02						;Input (Data, Var, Abs)
		.db 0xC0					;End_Collection 
		.db 0xC0				;End_Collection
EndOfNESReportDescriptor:

SEGAReportDescriptor:
        .db	0x05,0x01			;USAGE_PAGE (Generic Desktop)
        .db	0x09,0x04			;USAGE (Joystick)
        .db	0xA1,0x01				;COLLECTION (Application)
        .db 0x09,0x01				;USAGE (Pointer)
        .db 0xA1,0x00              	;COLLECTION (Physical)
		.db 0x85,0x01						;Report_ID (1)
		.db 0x09,0x30						;Usage (X) - OK
		.db 0x09,0x31						;Usage (Y) - OK
        .db 0x15,0x81                		;LOGICAL_MINIMUM (-7)
        .db 0x25,0x7f                		;LOGICAL_MAXIMUM (7)
		.db 0x75,0x08						;Report_Size (8)
		.db 0x95,0x02						;Report_Count (1)
		.db 0x81,0x02						;Input (Data, Var, Abs)
		.db 0x15,0x00						;Logical_Minimum (0)
		.db 0x25,0x01						;Logical Maximum (1)
		.db 0x95,0x08						;Report_Count (8)
		.db 0x75,0x01						;Report_Size (1)
		.db 0x05,0x09						;Usage_Page (Button)
		.db 0x19,0x01						;Usage_Minimum (Button 1)
		.db 0x29,0x08						;Usage_Maximum (Button 8)
		.db 0x81,0x02						;Input (Data, Var, Abs)
		.db 0xC0					;End_Collection 
		.db 0xC0				;End_Collection
EndOfSEGAReportDescriptor:
