;*************************************************************************
;**	send.asm, writen by Masyanya (ASDC) on 02.03.2007, main programmer of 
;** r.a.m. factory Co. design group.
;**	This file consists sending algoritms for USB interface
;** ver. 2.00 (evalution of version 1.03 from 07.03.2005) algorithms. 
;** ALL RIGHTS RESERVED for r.a.m. factory Co. Please remember this!!!!
;** Using frequency 15MHz :-) (bit stuffing included ;-) )
;*************************************************************************
/*
!Please remember!
This file is INTELLECTUAL PROPERTY of r.a.m. factory Co.
*/

 .include "other.inc"
 .include "USB.inc"

.cseg
;------------------------------------------------------------------------------------------
/*
Send8ZeroData:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglBulkDATAPID;Togle data PID

		lds		YL,USB_BulkBuffer
		sts		USB_BulkBuffer+1,YL
		sts		USB_BulkBuffer+2,YL
		sts		USB_BulkBuffer+3,YL
		sts		USB_BulkBuffer+4,YL
		sts		USB_BulkBuffer+5,YL
		sts		USB_BulkBuffer+6,YL
		sts		USB_BulkBuffer+7,YL
		sts		USB_BulkBuffer+8,YL

		cpi		YL,0xc3
		brne	DATA1
		ldi		YL,0x89
		sts		USB_BulkBuffer+9,YL
		ldi		YL,0x46
		sts		USB_BulkBuffer+10,YL
		rjmp	endfff
DATA1:
		ldi		YL,0xBB
		sts		USB_BulkBuffer+9,YL
		ldi		YL,0xF3
		sts		USB_BulkBuffer+10,YL
endfff:
		ldi		YL,0x0c
		mov		ByteCount,YL


		ldi	YL,low(USB_BulkBuffer)
		ldi	YH,high(USB_BulkBuffer)
		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret
*/
Send8ZeroData:
		push	YL
		push	YH
		push	ByteCount

		rcall	TglBulkDATAPID;Togle data PID

		lds		YL,USB_BulkBuffer
		sts		USB_BulkBuffer+1,YL
		sts		USB_BulkBuffer+2,YL
		sts		USB_BulkBuffer+3,YL
		sts		USB_BulkBuffer+4,YL
		sts		USB_BulkBuffer+5,YL
		sts		USB_BulkBuffer+6,YL
		sts		USB_BulkBuffer+7,YL
		sts		USB_BulkBuffer+8,YL

		ldi		ByteCount,0x0c-2
		ldi	YL,low(USB_BulkBuffer)
		ldi	YH,high(USB_BulkBuffer)
		rcall	CalcCRC16

		ldi		ByteCount,0x0c


		ldi	YL,low(USB_BulkBuffer)
		ldi	YH,high(USB_BulkBuffer)
		rcall	SendUSBBuffer

		pop		ByteCount
		pop		YH
		pop		YL
		ret

SendTripleZeroData:
		push	YL
		push	YH
		push	ByteCount

		rcall	ToggleDATAPID;Togle data PID

		clr		YL
		sts		USB_OutPacket+1,YL
		sts		USB_OutPacket+2,YL
		sts		USB_OutPacket+3,YL

		ldi		YL,0x8E
		sts		USB_OutPacket+4,YL
		ldi		YL,0x3F
		sts		USB_OutPacket+5,YL

		ldi		YL,0x07
		mov		ByteCount,YL

		rcall	SendUSBAnswer
		pop		ByteCount
		pop		YH
		pop		YL
		ret
SendDoubleZeroData:
		push	YL
		push	YH
		push	ByteCount

		rcall	ToggleDATAPID;Togle data PID

		clr		YL
		sts		USB_OutPacket+1,YL
		sts		USB_OutPacket+2,YL

		ldi		YL,0xFE
		sts		USB_OutPacket+3,YL
		ldi		YL,0x4F
		sts		USB_OutPacket+4,YL

		ldi		YL,0x06
		mov		ByteCount,YL

		rcall	SendUSBAnswer
		pop		ByteCount
		pop		YH
		pop		YL
		ret

SendEmptyBuffer:;This func make empty DATA0/1 packet
		push	YL
		push	YH
		push	ByteCount
;*********Store CRC16 for Empty Buffer**********
		clr		YL
		sts		TMPBUFFER+1,YL
		sts		TMPBUFFER+2,YL
;*********Togle data PID************************
		rcall	ToggleDATAPID
		lds 	YL,USB_OutPacket
		sts		TMPBUFFER,YL
;*********Make packet size**********************
		clr		ByteCount
		inc		ByteCount
		inc		ByteCount
;*********Send our packet to USB HOST***********
		rjmp	SendRestorePart

SendACK:;This function send ACK HENDSHAKE to USB HOST
		push	YL
		push	YH
		push	ByteCount
;*********Store "receive correctly" HANDSHAKE***
		ldi 	YL,ACKPID
		sts		TMPBUFFER,YL
;*********Only send PID=ACK*********************
		clr ByteCount
;*********Send HANDSHAKE packet to USB HOST*****
		rjmp	SendRestorePart

SendNAK:;This function send NAK HENDSHAKE to USB HOST
		push	YL
		push	YH
		push	ByteCount
;*********Store "Cannot communicate temporary" HANDSHAKE***
		ldi YL,NAKPID
		sts	TMPBUFFER,YL
;*********Only send PID=NAK*********************
		clr ByteCount

SendRestorePart:;This function send some helper packets
;Store buffer addr to send
		ldi	YH,high(TMPBUFFER)
		ldi	YL,low(TMPBUFFER)
;For SOP +1
		inc	ByteCount
;For PID +1
		inc	ByteCount
;Send packet
		rcall	SendUSBBuffer
;Restore used registers
		pop		ByteCount
		pop		YH
		pop		YL
		ret
;------------------------------------------------------------------------------------------
SendUSBAnswer:;Sending prepared output buffer
		ldi	YL,low(USB_OutPacket)
		ldi	YH,high(USB_OutPacket)
SendUSBBuffer:;Sending prepared user buffer stored in YH:YL,ByteCount - buffer size
SendComposedPacket:
;		cli;Clear global interrupt flag
		push	T00
		PUSH	XL
		push	T01
		push	T02
		push	ByteCount
		push	T03
		in		T02,PortDirector
		SBR		T02,(1<<DMinusChannel)|(1<<DPlusChannel)
		out		PortDirector,T02
		clr		T02
		ldi		XL,0b00000010

		in		T00,InPutPort
		ldi		T01,(1<<DPlusChannel)|(1<<DMinusChannel);|(1<<DINTChannel)
		cbr		T00,(1<<DMinusChannel)
		sbr		T00,(1<<DPlusChannel);|(1<<DINTChannel)
		eor		T00,T01
		ldi		T03,0x00
		out		OutPutPort,T00
		nop
		nop
		nop
		nop
		nop
		eor		T00,T01
		rjmp	StartSending
;load next byte
XL_00:
		eor		T00,T01
		nop;ror		XL
		ldi		XL,0b00000010
		nop
;		nop;888888
		out		OutPutPort,T00
		nop
		nop
		nop
		nop
		rjmp	ChangeSign_01A
XL_01:
		eor		T00,T01
		nop
		ldi		XL,0b00000010
		nop
;		nop;888888
;		nop;888888
;		nop;888888
		out		OutPutPort,T00
		nop
		nop
		rjmp	ChangeSign_02A
XL_02:
		eor		T00,T01
		nop
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		nop
		nop
		rjmp	ChangeSign_03A
XL_03:
		eor		T00,T01
		nop
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		nop
		nop
		rjmp	ChangeSign_04A
StartSending:
		ldi		BitInReg,SOP;Loading start of packet = 0x80
;start sending byte
;cycle 00
LoadNextByte:
ChangeSign_00A:
		lsr		BitInReg
		brcs	NoChangeSign_00
ChangeSign_00:
		eor		T00,T01
NoChangeSign_00:
		out		OutPutPort,T00
		brcs	NoChangeSign_00_
		ldi		XL,0b00000001
NoChangeSign_00_:
		lsl		XL
		BRVS	XL_00
		nop
		nop
;cycle 01
ChangeSign_01A:
		lsr		BitInReg
		brcs	NoChangeSign_01
ChangeSign_01:
		eor		T00,T01
NoChangeSign_01:
		out		OutPutPort,T00
		brcs	NoChangeSign_01_
		ldi		XL,0b00000001
NoChangeSign_01_:
		lsl		XL
		BRVS	XL_01
;cycle 02
ChangeSign_02A:
		lsr		BitInReg
		brcs	NoChangeSign_02
ChangeSign_02:
		eor		T00,T01
NoChangeSign_02:
		brcs	NoChangeSign_02_
		ldi		XL,0b00000001
NoChangeSign_02_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_02
		nop
		nop
;cycle 03
ChangeSign_03A:
		lsr		BitInReg
		brcs	NoChangeSign_03
ChangeSign_03:
		eor		T00,T01
NoChangeSign_03:
		brcs	NoChangeSign_03_
		ldi		XL,0b00000001
NoChangeSign_03_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_03
		nop
		nop
;cycle 04
ChangeSign_04A:
		lsr		BitInReg
		brcs	NoChangeSign_04
ChangeSign_04:
		eor		T00,T01
NoChangeSign_04:
		brcs	NoChangeSign_04_
		ldi		XL,0b00000001
NoChangeSign_04_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_04
		nop
		nop
;cycle _05
ChangeSign_05A:
		lsr		BitInReg
		brcs	NoChangeSign_05
ChangeSign_05:
		eor		T00,T01
NoChangeSign_05:
		brcs	NoChangeSign_05_
		ldi		XL,0b00000001
NoChangeSign_05_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_05
		nop
		nop
;cycle _06
ChangeSign_06A:
		lsr		BitInReg
		brcs	NoChangeSign_06
ChangeSign_06:
		eor		T00,T01
NoChangeSign_06:
		brcs	NoChangeSign_06_
		ldi		XL,0b00000001
NoChangeSign_06_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_06
;cycle _07
ChangeSign_07A:
		lsr		BitInReg
		brcs	NoChangeSign_07
ChangeSign_07:
		eor		T00,T01
NoChangeSign_07:
		ld		BitInReg,Y+
		brcs	NoChangeSign_07_
		ldi		XL,0b00000001
NoChangeSign_07_:
		out		OutPutPort,T00
		lsl		XL
		BRVS	XL_07

		dec		ByteCount
		cpse	ByteCount,T03
		rjmp	LoadNextByte
;cycle _00'
EndSending_:
		rjmp EndSending
EndSending_FromStuffing:
		nop
		nop
		rjmp EndSending
XL_04:
		eor		T00,T01
		nop
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		nop
		nop
		rjmp	ChangeSign_05A
XL_05:
		eor		T00,T01
		nop;ror		XL
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		nop
		nop
		rjmp	ChangeSign_06A
XL_06:
		eor		T00,T01
		nop
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		rjmp	ChangeSign_07A
XL_07:
		eor		T00,T01
		nop;ror		XL
		ldi		XL,0b00000010
		nop
		nop
		nop
		out		OutPutPort,T00
		dec		ByteCount
		breq	EndSending_FromStuffing
		nop
		nop
		rjmp	ChangeSign_00A

;end sending
EndSending:;Send EOP to host
		nop
		cbr		T00,(1<<DPlusChannel)|(1<<DMinusChannel);|(1<<DINTChannel)
		out		OutPutPort,T00
		pop		T03
		pop		ByteCount
		nop
		out		OutPutPort,T00
		pop		T02
		pop		T01
		nop
		sbr		T00,(1<<DMinusChannel);ZERO
		nop
		nop
		nop
		out		OutPutPort,T00
		nop
		in		T00,PortDirector
		nop
		nop
		nop
		pop		XL
		cbr		T00,(1<<DMinusChannel)|(1<<DPlusChannel)
		nop
		out		PortDirector,T00
		pop		T00
;		sei;Enable global interrupt flag
		ret
