 .include "data.inc"

.cseg
;Descriptor Type  Bits specifying characteristics of Descriptor Type: 
;7  Reserved (should always be 0) 
;6..5  Type 
;   0 = Standard 
;   1 = Class 
;   2 = Vendor 
;   3 = Reserved 
;4..0  Descriptor 
;See the standard class or vendor Descriptor Types table. 
PrepareUSBAnswer:
		clr	CurrentDataPosition	;Zero to CurrentDataPosition variable - reading from ROM
		lds	T00,USB_InPacket+1	;bmRequestType to T00
		lds	T01,USB_InPacket+2	;bRequest to T01
;		cbr	T00,0b10011111		;if is 5 and 6 bit zero
;		brne	VendorRequest	;then this isn't  Vendor Request
		cbr	T00,0b10011111		;if is 5 and 6 bit zero
		cpi	T00,STANDARD
		breq	StandardRequest	;This is standard requests
		cpi	T00,CLASS
		breq	ClassSpecificRequests	;This is Class Specific Request
		cpi	T00,VENDOR
		breq	VendorRequest	;This is Vendor Request

		rjmp	WhatA
;		rjmp	MakeDATAPID1EmptyBuffer ;we have no req. type
;**************************************************************************

OneZeroAnswer:		;send single zero
		ldi	T00,1	;number of my bytes answers to T00
		rjmp	ComposeGET_STATUS2
;******************** STANDARD USB REQUESTS ********************************
ClassSpecificRequests:
		cpi	T01,GET_REPORT		;
		breq	ComposeGET_REPORT		;

		cpi	T01,GET_IDLE		;
		breq	ComposeGET_IDLE		;

		cpi	T01,GET_PROTOCOL		;
		breq	ComposeGET_PROTOCOL		;

		cpi	T01,SET_REPORT		;
		breq	ComposeSET_REPORT		;

		cpi	T01,SET_IDLE		;
		breq	ComposeSET_IDLE		;

		cpi	T01,SET_PROTOCOL		;
		breq	ComposeSET_PROTOCOL		;

		rjmp	WhatA
;		rjmp	ZeroDATA1Answer			;if that was something unknown, then prepare zero answer

;--------- Class Requests ------------------

ComposeGET_REPORT:				;
;		rjmp	ZeroDATA1Answer
		rjmp	WhatA
ComposeGET_IDLE:
; ______________________________________________
;|			Description 		 |Pos in Buffer |
;|-------------------------------|--------------|
;|bmRequestType  10100001  		 |  +1 (BYTE)	|
;|bRequest  GET_IDLE 			 |	+2 (BYTE)	|
;|wValue  0 (zero) and Report ID |+4  +3 (2BYTE)|
;|wIndex  Interface 			 |  +5 (WORD)	|
;|wLength  1 (one) 				 |  +7 (WORD)	|
;|Data  Idle rate				 |  +9 (BYTE)	|
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	struct
;	{
;	 byte bmRequestType;
;	 byte bRequest;    
;	 word wValue;
;	 word wIndex;
;	 word wLength;
;	};
;		Get report ID IDLE For
;		lds	T01,USB_InPacket+3
		ldi	YH, high(USB_OutPacket)	;ROMpointer na odpoved	;ENG;ROMpointer to  answer
		ldi	YL, low(USB_OutPacket)
		lds	T03,ID1_IDLE
		std	Y+1,T03
;		ldi	T03,0x01
;		std	Y+1,T03
		ldi	T03,0x01;number of bytes
		rjmp	PrepareNormalBuffer		;Buffer prepared, add CRC16
ComposeGET_PROTOCOL:
		rjmp	WhatA
;		rjmp	ZeroDATA1Answer
ComposeSET_REPORT:
		rjmp	ZeroDATA1Answer
ComposeSET_IDLE:
		LDS		T00,USB_InPacket+9
		STS		ID1_IDLE,T00
		rjmp	ZeroDATA1Answer
ComposeSET_PROTOCOL:
		rjmp	ZeroDATA1Answer

VendorRequest:
;		clr	ZH				;pre citanie z RAM alebo EEPROM	;ENG;for reading from RAM or EEPROM
;		clr ZL
;		rjmp	MakeDATAPID1EmptyBuffer			;if that it was something unknown, then prepare zero answer
		rjmp	WhatA

StandardRequest:
		cpi	T01,GET_STATUS		;
		breq	ComposeGET_STATUS		;

		cpi	T01,CLEAR_FEATURE		;
		breq	ComposeCLEAR_FEATURE		;

		cpi	T01,SET_FEATURE		;
		breq	ComposeSET_FEATURE		;

		cpi	T01,SET_ADDRESS		;ak sa ma nastavit adresa	;ENG;if to set address
		breq	ComposeSET_ADDRESS		;nastav adresu	;ENG;set the address

		cpi	T01,GET_DESCRIPTOR		;ak sa ziada descriptor	;ENG;if requested descriptor
		breq	ComposeGET_DESCRIPTOR		;vygeneruj ho	;ENG;generate it

		cpi	T01,SET_DESCRIPTOR		;
		breq	ComposeSET_DESCRIPTOR		;

		cpi	T01,GET_CONFIGURATION		;
		breq	ComposeGET_CONFIGURATION	;

		cpi	T01,SET_CONFIGURATION		;
		breq	ComposeSET_CONFIGURATION	;

		cpi	T01,GET_INTERFACE		;
		breq	ComposeGET_INTERFACE		;

		cpi	T01,SET_INTERFACE		;
		breq	ComposeSET_INTERFACE		;

		cpi	T01,SYNCH_FRAME		;
		breq	ComposeSYNCH_FRAME		;
							;ak sa nenasla znama poziadavka	;ENG;if not found known request
		rjmp	WhatA
;		rjmp	MakeDATAPID1EmptyBuffer			;ak to bolo nieco nezname, tak priprav nulovu odpoved	;ENG;if that was something unknown, then prepare zero answer

ComposeSET_ADDRESS:
		lds	T01,USB_InPacket+3	;nova adresa do T01;	;ENG;new address to T01
;		rcall	SetMyNewUSBAddresses		;a pocitaj kodovanu (NRZI a bitstuffing) adresu	;ENG;and compute NRZI and bitstuffing coded adresses
		sts	DeviceAddressSRAM,T01	;ENG;store NRZI coded AddressOut
		ldi	EngineState,ADDRCH_STATE	;nastav stav zmeny adresy	;ENG;set state for Address changing
		rjmp	MakeDATAPID1EmptyBuffer			;posli nulovu odpoved	;ENG;send zero answer

ComposeSET_CONFIGURATION:
		lds	T00,USB_InPacket+3	;cislo konfiguracie do premennej ConfigByte	;ENG;number of configuration to variable ConfigByte
		sts	ConfigByte,T00		;
ComposeCLEAR_FEATURE:
ComposeSET_FEATURE:
ComposeSET_INTERFACE:
ZeroStringAnswer:
		rjmp	MakeDATAPID1EmptyBuffer			;posli nulovu odpoved	;ENG;send zero answer
ComposeGET_STATUS:
TwoZeroAnswer:
		ldi	T00,2			;Number of my bytes answers to T00
ComposeGET_STATUS2:
		ldi	YH, high(USB_OutPacket)	;ROMpointer na odpoved	;ENG;ROMpointer to  answer
		ldi	YL, low(USB_OutPacket)
		clr	T03
		std	Y+1,T03
		std	Y+2,T03
		mov	T03,T00		;+ number of bytes
		rjmp	PrepareNormalBuffer		;Buffer prepared, add CRC16
ComposeGET_CONFIGURATION:
		lds	T00,ConfigByte
		ldi	YH, high(USB_OutPacket)	;ROMpointer na odpoved	;ENG;ROMpointer to  answer
		ldi	YL, low(USB_OutPacket)
		std	Y+1,T00
		ldi	T03,1		;+ number of bytes
		rjmp	PrepareNormalBuffer		;Buffer prepared, add CRC16
ComposeGET_INTERFACE:
		lds	T00,ConfigByte
		ldi	YH, high(USB_OutPacket)	;ROMpointer na odpoved	;ENG;ROMpointer to  answer
		ldi	YL, low(USB_OutPacket)
		ldi	T00,0x01
		std	Y+1,T00
		ldi	T03,1		;+ number of bytes
		rjmp	PrepareNormalBuffer		;Buffer prepared, add CRC16
ComposeSYNCH_FRAME:
ComposeSET_DESCRIPTOR:
;		ldi	T00,STALLPID
;		sts	USB_OutPacket,T00	;STALLPID byte	;ENG;STALLPID byte
;		ldi	ByteCount,2			;dlzka vystupneho buffera (SOP a PID)	;ENG;length of output buffer (SOP and PID)
		rjmp	WhatA
ComposeGET_DESCRIPTOR:
		lds	T00,USB_InPacket+1	;bmRequestType to temp0
		cpi T00, 0b10000001
		breq	ComposeClassDescriptor
		lds	T01,USB_InPacket+4	;DescriptorType do T01	;ENG;DescriptorType to T01
		cpi	T01,DEVICE			;DeviceDescriptor	;ENG;DeviceDescriptor
		breq	ComposeDeviceDescriptor		;
		cpi	T01,CONFIGURATION		;ConfigurationDescriptor	;ENG;ConfigurationDescriptor
		breq	ComposeConfigDescriptor		;
		cpi	T01,STRING			;StringDeviceDescriptor	;ENG;StringDeviceDescriptor
		breq	ComposeStringDescriptor		;
		cpi	T01,INTERFACE			;InterfaceDeviceDescriptor
		breq	ComposeInterfaceDescriptor;

;		cpi	T01,CLASS_Physical			;StringDeviceDescriptor
;		breq	ComposePhysicalDescriptor

		rjmp	WhatA
;		ret

ComposeClassDescriptor:
		lds	T01,USB_InPacket+4	;DescriptorType to temp1
		cpi	T01,CLASS_HID			;HID class descripto
		breq	ComposeHIDClassDescriptor		;
		cpi	T01,CLASS_Report		;ConfigurationDescriptor
		breq	ComposeReportDescriptor		;
;		cpi	T01,CLASS_Physical			;StringDeviceDescriptor
;		breq	ComposePhysicalDescriptor
		rjmp	WhatA


ComposeHIDClassDescriptor:	
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(HIDJ1Descriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(HIDJ1Descriptor)
		ldi	T00,EndOfHIDJ1Descriptor-HIDJ1Descriptor			;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and complete

ComposeReportDescriptor:
		lds	T00,USB_InPacket+5
		cpi	T00,01
		breq JoyDevice2
		rjmp	AnotherReportDescriptors
		
JoyDevice2:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(ReportDescriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(ReportDescriptor)
		ldi	T00,EndOfReportDescriptor-ReportDescriptor	;number of my bytes answers to temp0			;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and complete

ComposeInterfaceDescriptor:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(Joy1InterfaceDescriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(Joy1InterfaceDescriptor)
		ldi	T00,EndOfJoy1InterfaceDescriptor-Joy1InterfaceDescriptor	;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and completen
ComposeDeviceDescriptor:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(DeviceDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(DeviceDescriptor)
		ldi	T00,EndOfDeviceDescriptor-DeviceDescriptor			;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeConfigDescriptor:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(ConfigDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(ConfigDescriptor)
		ldi	T00,ConfigDescriptorEnd-ConfigDescriptor			;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor

ComposeStringDescriptor:
;LANGID
;MANUFACTURER
;PRODUCT
;SERIAL
		ldi	T00,0x80|0x08			;ak CurrentDataPosition=0x10(vkladaj nuly z ROM-koveho citania) + 8(za prvy byte nevkldadaj nulu)	;ENG;if CurrentDataPosition=4(insert zeros from ROM reading) + 8(behind first byte no load zero)
		mov	CurrentDataPosition,T00

		lds	T01,USB_InPacket+3	;DescriptorIndex do T01	;ENG;DescriptorIndex to T01

		cpi	T01,MANUFACTURER				;DevNameString	;ENG;DevNameString
		breq	ComposeManufacturerString		;

		cpi	T01,PRODUCT				;DevNameString	;ENG;DevNameString
		breq	ComposeProductString

		cpi	T01,JOY1NAME				;DevNameString	;ENG;DevNameString
		breq	ComposeJoy1NameString

		cpi	T01,JOY2NAME				;DevNameString	;ENG;DevNameString
		breq	ComposeJoy2NameString

		cpi	T01,NESNAME				;DevNameString	;ENG;DevNameString
		breq	ComposeNESNameString

		cpi	T01,SEGANAME				;DevNameString	;ENG;DevNameString
		breq	ComposeSEGANameString

		cpi	T01,SERIAL				;DevNameString	;ENG;DevNameString
		breq	ComposeSerialString

		cpi	T01,CRSERIAL
		breq	ComposeCRString

		cpi	T01,LANGID				;LANGID String
		breq	ComposeLangIDString		;
		rjmp	ZeroStringAnswer		;ak je DescriptorIndex vyssi nez 2 - posli nulovu odpoved	;ENG;if is DescriptorIndex higher than 2 - send zero answer

					;inak to bude VendorString	;ENG;otherwise is VendorString
ComposeCRString:
		ldi	ZH, high(CRDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(CRDescriptor)
		ldi	T00,(CRDescriptorEnd-CRDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeJoy1NameString:
		ldi	ZH, high(Joy1NameDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(Joy1NameDescriptor)
		ldi	T00,(Joy1NameDescriptorEnd-Joy1NameDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeNESNameString:
		ldi	ZH, high(NESNameDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(NESNameDescriptor)
		ldi	T00,(NESNameDescriptorEnd-NESNameDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete

ComposeSEGANameString:
		ldi	ZH, high(SEGANameDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(SEGANameDescriptor)
		ldi	T00,(SEGANameDescriptorEnd-SEGANameDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete

ComposeJoy2NameString:
		ldi	ZH, high(Joy2NameDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(Joy2NameDescriptor)
		ldi	T00,(Joy2NameDescriptorEnd-Joy2NameDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeSerialString:
		ldi	ZH, high(SerialDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(SerialDescriptor)
		ldi	T00,(SerialDescriptorEnd-SerialDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeProductString:
		ldi	ZH, high(ProductDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(ProductDescriptor)
		ldi	T00,(ProductDescriptorEnd-ProductDescriptor-1)*2	;pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeManufacturerString:
		ldi	ZH, high(ManufacturerDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(ManufacturerDescriptor)
		ldi	T00,(ManufacturerDescriptorEnd-ManufacturerDescriptor-1)*2;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
ComposeLangIDString:
		ldi	T00,0x02
		mov CurrentDataPosition,T00
		ldi	ZH, high(LangIDStringDescriptor)	;ROMpointer na descriptor	;ENG;ROMpointer to descriptor
		ldi	ZL,  low(LangIDStringDescriptor)
		ldi	T00,(LangIDStringDescriptorEnd-LangIDStringDescriptor);pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
;		ldi	T03,(LangIDStringDescriptorEnd-LangIDStringDescriptor);pocet mojich bytovych odpovedi do T00	;ENG;number of my bytes answers to T00
;		mov	ByteCount,T03
;		rcall	LoadMyPacketData
;		rjmp	PrepareNormalBuffer		;Buffer prepared, add CRC16
		rjmp	ComposeEndXXXDescriptor		;a dokonci	;ENG;and complete
;------------------------------------------------------------------------------------------
;ZeroDATA1Answer:
;		rcall	MakeDATAPID1EmptyBuffer
;		ret
;------------------------------------------------------------------------------------------
ComposeEndXXXDescriptor:
		lds	TotalBytesToSend,USB_InPacket+7	;pocet pozadovanych bytov do TotalBytesToSend	;ENG;number of requested bytes to TotalBytesToSend
		cp	TotalBytesToSend,T00			;ak sa neziada viac ako mozem dodat	;ENG;if not requested more than I can send
		brcs	HostConfigLength		;vysli tolko kolko sa ziada	;ENG;transmit the requested number
		mov	TotalBytesToSend,T00		;inak posli pocet mojich odpovedi	;ENG;otherwise send number of my answers
HostConfigLength:
		mov	T00,TotalBytesToSend		;
		clr	TransmitPart			;nuluj pocet 8 bytovych odpovedi	;ENG;zero the number of 8 bytes answers
		andi	T00,0b00000111		;ak je dlzka delitelna 8-mimi	;ENG;if is length divisible by 8
		breq	Length8Multiply			;tak nezapocitaj jednu necelu odpoved (pod 8 bytov)	;ENG;then not count one answer (under 8 byte)
		inc	TransmitPart			;inak ju zapocitaj	;ENG;otherwise count it
Length8Multiply:
		mov	T00,TotalBytesToSend		;
;		lsr	T00				;dlzka 8 bytovych odpovedi sa dosiahne	;ENG;length of 8 bytes answers will reach
;		lsr	T00				;delenie celociselne 8-mimi	;ENG;integer division by 8
;		lsr	T00
;		add	TransmitPart,T00		;a pripocitanim k poslednej necelej 8-mici do premennej TransmitPart	;ENG;and by addition to last non entire 8-bytes to variable TransmitPart
LengthNormalSend:
		mov		T01,T00
		lsr		T01
		lsr		T01
		lsr		T01
		inc		T01
		mov		TransmitPart,T01
		andi	T00,0b00000111;receive last packet size
		mov		TotalBytesToSend,T00

		ldi	T00,DATA0PID			;DATA0 PID - v skutocnosti sa stoggluje na DATA1PID v nahrati deskriptora	;ENG;DATA0 PID - in the next will be toggled to DATA1PID in load descriptor
		sts	USB_OutPacket,T00	;nahraj do vyst buffera	;ENG;store to output buffer

		rjmp	PrepareContinuousBuffer

MakeDATAPID1EmptyBuffer:
		ldi	T00,DATA1PID			;DATA0 PID
		sts USB_BulkBuffer,T00
ZeroDATA1Answer:
		ldi	T00,DATA0PID			;DATA0 PID
		sts	USB_OutPacket,T00	;nahraj do vyst buffera	;ENG;load to output buffer
MakeEmptyBuffer:
;		ldi	T00,SOPbyte
;		sts	USB_OutPacket+0,T00	;SOP byte	;ENG;SOP byte
		rcall	ToggleDATAPID			;zmen DATAPID	;ENG;change DATAPID
		ldi	T00,0x00
		sts	USB_OutPacket+1,T00	;CRC byte	;ENG;CRC byte
		sts	USB_OutPacket+2,T00	;CRC byte	;ENG;CRC byte
		ldi	ByteCount,2+2			;dlzka vystupneho buffera (SOP a PID + CRC16)	;ENG;length of output buffer (SOP and PID + CRC16)
		ret

WhatA:
		clr CurrentDataPosition
		inc CurrentDataPosition
		ldi	ZH, high(USB_InPacket+1)	;ROMpointer to descriptor
		ldi	ZL,  low(USB_InPacket+1)
		ldi	T00,8			;number of my bytes answers to temp0
		rjmp	LengthNormalSend
;		rjmp	ComposeEndXXXDescriptor		;and complete
AnotherReportDescriptors:
		cpi	T00,03
		breq NesDevice
		cpi	T00,04
		breq NesDevice

		cpi	T00,05
		breq SegaDevice
		cpi	T00,06
		breq SegaDevice
;Report for second joy
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(ReportDescriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(ReportDescriptor)
		ldi	T00,EndOfReportDescriptor-ReportDescriptor	;number of my bytes answers to temp0			;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and complete

SegaDevice:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(SEGAReportDescriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(SEGAReportDescriptor)
		ldi	T00,EndOfSEGAReportDescriptor-SEGAReportDescriptor	;number of my bytes answers to temp0			;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and complete
NesDevice:
		ldi T00,0x2
		mov CurrentDataPosition,T00
		ldi	ZH, high(NESReportDescriptor)	;ROMpointer to descriptor
		ldi	ZL,  low(NESReportDescriptor)
		ldi	T00,EndOfNESReportDescriptor-NESReportDescriptor	;number of my bytes answers to temp0			;number of my bytes answers to temp0
		rjmp	ComposeEndXXXDescriptor		;and complete
