;*************************************************************************
;**	USB.inc, writen by Masyanya (ASDC) on 02.03.2007, main programmer of 
;** r.a.m. factory Co. design group.
;**	This file consists main USB defines constants and some other needed USB interface
;** ver. 2.00 (evalution of version 1.03 from 07.03.2005) algorithms. 
;** ALL RIGHTS RESERVED for r.a.m. factory Co. Please remember this!!!!
;** Using frequency 15MHz :-)
;*************************************************************************
/*
!Please remember!
This file is INTELLECTUAL PROPERTY of r.a.m. factory Co.
*/

#ifndef _USB_INC
#define _USB_INC

;************USB Pipe identifiers*********************
;.equ	BULK_PACKET_CHANKS	=0x01 ;May be 0->0x8,1->0x10,2->0x20
.equ	BULK_INPACKET_SIZE	=8 ;May be 0x8,0x10,0x20
.equ	BULK_OUTPACKET_SIZE	=8 ;May be 0x8,0x10,0x20
.equ	BULK_PACKET_SIZE	=8 ;May be 0x8,0x10,0x20
.equ	EMPTY_BUFFER_SIZE	=0x04

;************USB Packet identifiers*******************
.equ	SOP				=0b10000000	;Start of Packet

;Token packets: Sync PID ADDR ENDP CRC5 EOP
.equ	OUTPID			=0b11100001	;PID OUT Packet
.equ	INPID			=0b01101001	;PID IN Packet
.equ	SETUPPID		=0b00101101	;PID SETUP Packet

;Start of Frame Packets: Sync PID Frame Number CRC5 EOP
.equ	SOFPID			=0b10100101	;PID SOF Packet

;Data packets: Sync PID Data CRC16 EOP
.equ	DATA0PID		=0b11000011	;PID DATA0 Packet
.equ	DATA1PID		=0b01001011	;PID DATA1 Packet
.equ	DATA2PID		=0b10000111	;PID DATA0 Packet
.equ	MDATAPID		=0b00001111	;PID DATA1 Packet

;Handshake packets: Sync PID EOP
.equ	ACKPID			=0b11010010	;PID ACK Packet
.equ	NAKPID			=0b01011010	;PID NAK Packet
.equ	STALLPID		=0b00011110	;PID STALL Packet
.equ	NYETPID			=0b10010110	;PID NYET Packet

.equ	PREPID			=0b00111100	;Preamble PID Packet
.equ	ERRPID			=0b00111100	;Error PID Packet
.equ	SPLITPID		=0b01111000	;Split PID Packet
.equ	PINGPID			=0b10110100	;Ping PID Packet

;************Types of descriptors*******************
.equ	DEVICE			=1
.equ	CONFIGURATION	=2
.equ	STRING			=3
.equ	INTERFACE		=4
.equ	ENDPOINT		=5

;************Types of HID descriptors*******************
.equ	CLASS_HID		=0x21
.equ	CLASS_Report	=0x22
.equ	CLASS_Physical	=0x23

;************Descriptor Type  Bits specifying***********
;   0 = Standard 
;   1 = Class 
;   2 = Vendor 
.equ	STANDARD		=0x00<<5
.equ	CLASS			=0x01<<5
.equ	VENDOR			=0x02<<5

;************Standart Descriptors requirements*******************
.equ	GET_STATUS			=0
.equ	CLEAR_FEATURE		=1
.equ	SET_FEATURE			=3
.equ	SET_ADDRESS			=5
.equ	GET_DESCRIPTOR		=6
.equ	SET_DESCRIPTOR		=7
.equ	GET_CONFIGURATION	=8
.equ	SET_CONFIGURATION	=9
.equ	GET_INTERFACE		=10
.equ	SET_INTERFACE		=11
.equ	SYNCH_FRAME			=12

;************Class-Specific Requests*****************************
.equ	GET_REPORT   		=0x01
.equ	GET_IDLE 			=0x02
.equ	GET_PROTOCOL		=0x03
.equ	SET_REPORT 			=0x09
.equ	SET_IDLE 			=0x0A
.equ	SET_PROTOCOL 		=0x0B

;************SETUP SIGN DECLARATION********************
.equ	SETUP_IN_PROCESS			=0x07

;GLOBAL REGISTER FLAGS
;************Used for HOST acknologements**************
.equ	WAIT_ACK					=0x00
.equ	HOST_NAK					=0x01

;************Our USB Device statuses*******************
.equ	DO_NOTHING					=0
.equ	DO_RECEIVE_OUT_DATA			=1
.equ	DO_SETUP_DATA				=2
.equ	DO_BUFFER_SEPARATION		=3
.equ	DO_ANSWER_PREPARED			=4
;************Our USB Device statuses for PSREADER******
.equ	DO_PS_DATA_CARD				=5
.equ	DO_PS_DATA_SENDER			=6
;*******************Force FEEDBACK Commands************
.equ	DO_PS_FEEDBACK_1			=0x08
.equ	DO_PS_FEEDBACK_2			=0x09
.equ	DO_PS_LAST_PACKET			=0x0b

;************Our USB Device statuses*******************
.equ	BASE_STATE			=0		;base status, no operations
.equ	SETUP_STATE			=1		;device in setup state
.equ	IN_STATE			=2		;in data state
.equ	OUT_STATE			=3		;out data state
.equ	SOF_STATE			=4		;start or frame status
.equ	DATA_STATE			=5		;data receive state
.equ	ADDRCH_STATE		=6		;changing address state
;Our data bulk flags
;.equ	OUT_EP_1			=7		;Receive data endpoint
.equ	NO_ADDRESS			=0x80	;device no have address



.equ	DO_SETUP_BUFFER_SEPARATION	=DO_BUFFER_SEPARATION|(1<<SETUP_IN_PROCESS)
.equ	DO_SETUP_ANSWER_PREPARED	=DO_ANSWER_PREPARED|(1<<SETUP_IN_PROCESS)
#endif
